/*
 * gc global variable provides access to GUI Composer infrastructure components and project information.
 * For more information, please see the Working with Javascript guide in the online help.
 */
var gc = gc || {};
gc.services = gc.services || {};
var saveAsFilePath; // undefined initially

//
/*[ Start of file stream code
var mystream;
var mywriter;
var myTextEnc = new TextEncoder();
var saveStart = function(filename) {
    if (!filename) filename = 'mydata.csv';
    mystream = streamSaver.createWriteStream(filename);
    mywriter = mystream.getWriter();
	saveData(myTextEnc.encode('Temperature, Time\n'));
};
var saveStop = function() {
    if (mywriter) {
        mywriter.close();
        mywriter = null;
    }
};
var saveAbort = function() {
    if (mywriter){
        mywriter.abort('reason');
        mywriter = null;
    }
};
var saveData = function(data) {
    if (mywriter) {
        mywriter.write(data);
    }
};
window.addEventListener('unload', (event) => {
//  console.log('unload', event);
  saveAbort(); // seems ok but please test.
});
var saveDummyData = function() {
    // To save textual data use TextEncoder to encode the data first
    var my_text = 'abcdef 01234 ABCDEF 56789 some text to go ... done';
    var myary = myTextEnc.encode(my_text + '\n');
    saveData(myary);
    // To save byte array data like below, no need to encode it.
    //saveData([1,2,3,4,5,6,7,8,9,10, 100,101]);  
};
*/// End of file stream code ]


var convertTemp = function(value, isToCelsius) {
    var result = value;
    if (isToCelsius) {
        result = (value - 32) / 1.8;
    } else {
        result = (value * 1.8) + 32;
    }
    return result;
};

var getF = function(value){
	return (value * 1.8) + 32;
};
var getC = function(value){
    return (value - 32) / 1.8;
};
var twosComp = function(value){
      var result = value-8192;
      return result;
};

var twosComp_offset = function(value){
      var result = value-8192;
      return result;
};

var twosComp_nfactor = function(value){
      var result = value-512;
      return result;
};

var twosComp_THERM = function(value){
      var result = value-1024;
      return result;
};

var RegTemp2Deci = function(value){
            var result = value;
            if(result>=4096){
                result = twosComp(result);
                
            }
            result = (result*0.0625);
            if(tempScale === "F"){
                result = getF(result);
                result = Math.round((result*10000))/10000;
            }
            return result;
    
};

var RegTemp2Deci_THERM = function(value){
            var result = value;
            if(result>=512){
                result = twosComp_THERM(result);
                
            }
            result = (result*0.5);
            if(tempScale === "F"){
                result = getF(result);
                result = Math.round((result*10000))/10000;
            }
            return result;
    
};

var RegTemp2Deci_HYS = function(value){
            var result = value;
            result = (result);
            if(tempScale === "F"){
                result = result*1.8;
                result = Math.round((result*10000))/10000;
            }
            return result;
    
};


var RegTemp2Deci_OFFSET = function(value){
            var result = value;
             if(result>=4096){
                result = twosComp_offset(result);
                
            }
            result = result/16;
            if(tempScale === "F"){
                result = result*1.8;
                result = Math.round((result*10000))/10000;
            }
            return result;
};

var DeciTemp2RegValue = function(value){
            if(tempScale === "F"){
                value = getC(value);
            }
            var result = value*16;
            return result;
    
};

var DeciTemp2RegValue_HYS = function(value){
            if(tempScale === "F"){
                value = value/1.8;
            }
            var result = value;
            return result;
    
};

var DeciTemp2RegValue_THERM = function(value){
            if(tempScale === "F"){
                value = getC(value);
            }
            var result = value*2;
            return result;
    
};

var DeciTemp2RegValue_OFFSET = function(value){
           var result = value;
            if(tempScale === "F"){
                result = result/1.8;
            }
            result = result*16;
            return result;
    
};

var tempScale = "C";
var newconnection = false;


//Standard Values
var C_Range_low_standard = -64;
var C_Range_high_standard = 191;
var F_Range_low_standard = -83.2;
var F_Range_high_standard = 375.8;
var C_Slider_labels_standard = '-64,-32,0,32,64,96,128,160,191';
var F_Slider_labels_standard = '-83.2,32,147.2,262.4,375.8';




var C_Slider_increment = 0.0625;
var F_Slider_increment = 0.1125;

var sampleTimeArray = [];   // Array for time-samples
var saveText = function(fname, text) {
    var blob = new Blob([text], {
        type: 'text/plain;charset=utf-8'
    });
    saveAs(blob, fname);

    return false;
};


function convertTimestamp(timestamp) {
    var d = new Date(timestamp), // Convert the passed timestamp to milliseconds
        yyyy = d.getFullYear(),
        mm = ('0' + (d.getMonth() + 1)).slice(-2), // Months are zero based. Add leading 0.
        dd = ('0' + d.getDate()).slice(-2), // Add leading 0.
        hh = d.getHours(),
        h = hh,
        min = ('0' + d.getMinutes()).slice(-2), // Add leading 0.
        ampm = 'AM',
        time;

    if (hh > 12) {
        h = hh - 12;
        ampm = 'PM';
    } else if (hh === 12) {
        h = 12;
        ampm = 'PM';
    } else if (hh === 0) {
        h = 12;
    }

    // ie: 2013-02-18, 8:35 AM	
    time = +h + ':' + min + ' ' + ampm + ',' + yyyy + '-' + mm + '-' + dd;

    return time;
}

var getHex16 = function(value) {
    // convert the register value into a human readable format for the GUI and convert to F if needed
    var result = gc.utils.getHexString(value, 16, "0x");
    return result;
};

// var getHex8 = function(value) {
//     // convert the register value into a human readable format for the GUI and convert to F if needed
//     var result = gc.utils.getHexString(value, 8, "0x");
//     return result;
// };





/*
 *  Boilerplate code for creating computed data bindings
 */
document.addEventListener('gc-databind-ready', function() {
    /*
     *   Add custom computed value databindings here, using the following method:
     *
     *   function gc.databind.registry.bind(targetBinding, modelBinding, [getter], [setter]);
     *
     *   param targetBinding - single binding string or expression, or array of binding strings for multi-way binding.
     *   param modelBinding - single binding string or expression, or array of binding strings for multi-way binding.
     *   param getter - (optional) - custom getter function for computing the targetBinding value(s) based on modelBinding value(s).
     *   param setter - (optional) - custom setter function for computing the modelBinding value(s) based on targetBinding value(s).
     */

    // For example, a simple computed values based on simple expression
    // gc.databind.registry.bind('widget.id.propertyName', "targetVariable == 1 ? 'binding is one' : 'binding is not one'");

    // Or a custom two-way binding with custome getter and setter functions.  (setter is optional)  (getter only indicates one-way binding)
    // gc.databind.registry.bind('widget.id.propertyName', "targetVariable", function(value) { return value*5/9 + 32; }, function(value) { (return value-32)*9/5; });

    // Event 1 to n bindings
    /*
    gc.databind.registry.bind('widget.date.value',
        // dependant bindings needed in order to compute the date, in name/value pairs.
        {
            weekday: 'widget.dayOfWeek.selectedText',
            day: 'widget.dayOfMonth.value',
            month: 'widget.month.selectedText',
            year: 'widget.year.value'
        },
        // getter for date computation
        function(values)
        {
            // compute and return the string value to bind to the widget with id 'date'
            return values.weekday + ', ' + values.month + ' ' + values.day + ', ' + values.year;
        }
    );
	*/


    // gc.connectionManager.addEventListener('status-updated', function(event) {
    //              if(gc.connectionManager.status === 'connected'){
    //                     newconnection = true;
    //         	       var bind = gc.databind.registry.getBinding('reg.N_FACTOR_CORRECTION.NFC');
    //         				bind.setValue(8);
    //              }
    //             });

    gc.connectionManager.addEventListener('status-changed', function(event) {
//                 if(gc.connectionManager.status === 'connected'){
                        newconnection = true;
            	       var bind = gc.databind.registry.getBinding('reg.LOCK.LOCK');
            				bind.setValue(60185);
//                 }
                    if(gc.connectionManager.status === 'connected'){
                             bind = gc.databind.registry.getBinding('reg.RTEMP1_N_FACTOR.RTEMP1_N_FACTOR');
            				bind.setValue(17);
            				 bind = gc.databind.registry.getBinding('reg.RTEMP2_N_FACTOR.RTEMP2_N_FACTOR');
            				bind.setValue(17);
            				 bind = gc.databind.registry.getBinding('reg.RTEMP3_N_FACTOR.RTEMP3_N_FACTOR');
            				bind.setValue(17);
            				 bind = gc.databind.registry.getBinding('reg.RTEMP4_N_FACTOR.RTEMP4_N_FACTOR');
            				bind.setValue(17);
            				 bind = gc.databind.registry.getBinding('reg.RTEMP5_N_FACTOR.RTEMP5_N_FACTOR');
            				bind.setValue(17);
            				 bind = gc.databind.registry.getBinding('reg.RTEMP6_N_FACTOR.RTEMP6_N_FACTOR');
            				bind.setValue(17);
            				 bind = gc.databind.registry.getBinding('reg.RTEMP7_N_FACTOR.RTEMP7_N_FACTOR');
            				bind.setValue(17);
            				 bind = gc.databind.registry.getBinding('reg.RTEMP8_N_FACTOR.RTEMP8_N_FACTOR');
            				bind.setValue(17);
                    }
                });	

    let  u2aConnectFn = gc.databind.USB2ANY.prototype.connect;
                gc.databind.USB2ANY.prototype.connect = function() { 
        return u2aConnectFn.apply(this, arguments).then(function() {
            var registerModel = gc.databind.registry.getModel('reg'); 
            return this.writeValue(registerModel.getRegisterInfo('LOCK'), 60185, registerModel);
        }.bind(this));
    };
///Lock Enable
	gc.databind.registry.bind('widget.ti_tile_toggleswitch_reglock.value','reg.LOCK.LOCK',
        function(value) {
            // convert register value spinner value
            var result = value;
            if(result===0 | result===60185){
                result = false;
                }
            else if(result===32768 | result===23718){
                result = true;
                }
            else{
                result = templateObj.$.ti_tile_toggleswitch_reglock.value;
            }
            return result;
        },
        function(value) {
            // convert toggle  value register value
            var result = value;
            if(!result){
                result = 60185;
                }
                else{
                result = 23718;
                }
            return result;
        },
    );


//N-Factor Calculation, 
	gc.databind.registry.bind('widget.ti_widget_spinner_settings_nfactor1.value','reg.RTEMP1_N_FACTOR.RTEMP1_N_FACTOR',
        function(value) {
            // convert register value spinner value
            var result = value;
            if(result>127){
                result = twosComp_nfactor(result);
                }
            result = (1.008*2088)/(2088+result);
            return result;
        },
        function(value) {
            // Convert Spinner to Register value
            var result = value;
            result = Math.round(((1.008*2088)/result)-2088);
            if(newconnection){
                result = 17;
                newconnection = false;
            }
            return result;
        }
    );

 
	gc.databind.registry.bind('widget.ti_widget_spinner_settings_nfactor2.value','reg.RTEMP2_N_FACTOR.RTEMP2_N_FACTOR',
        function(value) {
            // convert register value spinner value
            var result = value;
            if(result>127){
                result = twosComp_nfactor(result);
                }
            result = (1.008*2088)/(2088+result);
            return result;
        },
        function(value) {
            // Convert Spinner to Register value
            var result = value;
            result = Math.round(((1.008*2088)/result)-2088);
            if(newconnection){
                result = 17;
                newconnection = false;
            }
            return result;
        }
    );


	gc.databind.registry.bind('widget.ti_widget_spinner_settings_nfactor3.value','reg.RTEMP3_N_FACTOR.RTEMP3_N_FACTOR',
        function(value) {
            // convert register value spinner value
            var result = value;
            if(result>127){
                result = twosComp_nfactor(result);
                }
            result = (1.008*2088)/(2088+result);
            return result;
        },
        function(value) {
            // Convert Spinner to Register value
            var result = value;
            result = Math.round(((1.008*2088)/result)-2088);
            if(newconnection){
                result = 17;
                newconnection = false;
            }
            return result;
        }
    );

	gc.databind.registry.bind('widget.ti_widget_spinner_settings_nfactor4.value','reg.RTEMP4_N_FACTOR.RTEMP4_N_FACTOR',
        function(value) {
            // convert register value spinner value
            var result = value;
            if(result>127){
                result = twosComp_nfactor(result);
                }
            result = (1.008*2088)/(2088+result);
            return result;
        },
        function(value) {
            // Convert Spinner to Register value
            var result = value;
            result = Math.round(((1.008*2088)/result)-2088);
            if(newconnection){
                result = 17;
                newconnection = false;
            }
            return result;
        }
    );

	gc.databind.registry.bind('widget.ti_widget_spinner_settings_nfactor5.value','reg.RTEMP5_N_FACTOR.RTEMP5_N_FACTOR',
        function(value) {
            // convert register value spinner value
            var result = value;
            if(result>127){
                result = twosComp_nfactor(result);
                }
            result = (1.008*2088)/(2088+result);
            return result;
        },
        function(value) {
            // Convert Spinner to Register value
            var result = value;
            result = Math.round(((1.008*2088)/result)-2088);
            if(newconnection){
                result = 17;
                newconnection = false;
            }
            return result;
        }
    );

	gc.databind.registry.bind('widget.ti_widget_spinner_settings_nfactor6.value','reg.RTEMP6_N_FACTOR.RTEMP6_N_FACTOR',
        function(value) {
            // convert register value spinner value
            var result = value;
            if(result>127){
                result = twosComp_nfactor(result);
                }
            result = (1.008*2088)/(2088+result);
            return result;
        },
        function(value) {
            // Convert Spinner to Register value
            var result = value;
            result = Math.round(((1.008*2088)/result)-2088);
            if(newconnection){
                result = 17;
                newconnection = false;
            }
            return result;
        }
    );

	gc.databind.registry.bind('widget.ti_widget_spinner_settings_nfactor7.value','reg.RTEMP7_N_FACTOR.RTEMP7_N_FACTOR',
        function(value) {
            // convert register value spinner value
            var result = value;
            if(result>127){
                result = twosComp_nfactor(result);
                }
            result = (1.008*2088)/(2088+result);
            return result;
        },
        function(value) {
            // Convert Spinner to Register value
            var result = value;
            result = Math.round(((1.008*2088)/result)-2088);
            if(newconnection){
                result = 17;
                newconnection = false;
            }
            return result;
        }
    );

	gc.databind.registry.bind('widget.ti_widget_spinner_settings_nfactor8.value','reg.RTEMP8_N_FACTOR.RTEMP8_N_FACTOR',
        function(value) {
            // convert register value spinner value
            var result = value;
            if(result>127){
                result = twosComp_nfactor(result);
                }
            result = (1.008*2088)/(2088+result);
            return result;
        },
        function(value) {
            // Convert Spinner to Register value
            var result = value;
            result = Math.round(((1.008*2088)/result)-2088);
            if(newconnection){
                result = 17;
                newconnection = false;
            }
            return result;
        }
    );



//offset///////////////////////////

	gc.databind.registry.bind('widget.ti_widget_spinner_offset1.value','reg.RTEMP1_OFF_CONFIG.RTEMP1_OFF',
        function(value) {
            // convert register value spinner value
            var result = value;
            result = RegTemp2Deci_OFFSET(gc.databind.registry.getBinding('reg.RTEMP1_OFF_CONFIG.RTEMP1_OFF').getValue());
            return result;
        },
        function(value) {
            // Convert Spinner to Register value
            var result = value;
            var result = DeciTemp2RegValue_OFFSET(value);
			return result;
        }
    );


	gc.databind.registry.bind('widget.ti_widget_spinner_offset2.value','reg.RTEMP2_OFF_CONFIG.RTEMP2_OFF',
        function(value) {
            // convert register value spinner value
            var result = value;
            result = RegTemp2Deci_OFFSET(gc.databind.registry.getBinding('reg.RTEMP2_OFF_CONFIG.RTEMP2_OFF').getValue());
            return result;
        },
        function(value) {
            // Convert Spinner to Register value
            var result = value;
            var result = DeciTemp2RegValue_OFFSET(value);
			return result;
        }
    );


	gc.databind.registry.bind('widget.ti_widget_spinner_offset3.value','reg.RTEMP3_OFF_CONFIG.RTEMP3_OFF',
        function(value) {
            // convert register value spinner value
            var result = value;
            result = RegTemp2Deci_OFFSET(gc.databind.registry.getBinding('reg.RTEMP3_OFF_CONFIG.RTEMP3_OFF').getValue());
            return result;
        },
        function(value) {
            // Convert Spinner to Register value
            var result = value;
            var result = DeciTemp2RegValue_OFFSET(value);
			return result;
        }
    );


	gc.databind.registry.bind('widget.ti_widget_spinner_offset4.value','reg.RTEMP4_OFF_CONFIG.RTEMP4_OFF',
        function(value) {
            // convert register value spinner value
            var result = value;
            result = RegTemp2Deci_OFFSET(gc.databind.registry.getBinding('reg.RTEMP4_OFF_CONFIG.RTEMP4_OFF').getValue());
            return result;
        },
        function(value) {
            // Convert Spinner to Register value
            var result = value;
            var result = DeciTemp2RegValue_OFFSET(value);
			return result;
        }
    );


	gc.databind.registry.bind('widget.ti_widget_spinner_offset5.value','reg.RTEMP5_OFF_CONFIG.RTEMP5_OFF',
        function(value) {
            // convert register value spinner value
            var result = value;
            result = RegTemp2Deci_OFFSET(gc.databind.registry.getBinding('reg.RTEMP5_OFF_CONFIG.RTEMP5_OFF').getValue());
            return result;
        },
        function(value) {
            // Convert Spinner to Register value
            var result = value;
            var result = DeciTemp2RegValue_OFFSET(value);
			return result;
        }
    );


	gc.databind.registry.bind('widget.ti_widget_spinner_offset6.value','reg.RTEMP6_OFF_CONFIG.RTEMP6_OFF',
        function(value) {
            // convert register value spinner value
            var result = value;
            result = RegTemp2Deci_OFFSET(gc.databind.registry.getBinding('reg.RTEMP6_OFF_CONFIG.RTEMP6_OFF').getValue());
            return result;
        },
        function(value) {
            // Convert Spinner to Register value
            var result = value;
            var result = DeciTemp2RegValue_OFFSET(value);
			return result;
        }
    );


	gc.databind.registry.bind('widget.ti_widget_spinner_offset7.value','reg.RTEMP7_OFF_CONFIG.RTEMP7_OFF',
        function(value) {
            // convert register value spinner value
            var result = value;
            result = RegTemp2Deci_OFFSET(gc.databind.registry.getBinding('reg.RTEMP7_OFF_CONFIG.RTEMP7_OFF').getValue());
            return result;
        },
        function(value) {
            // Convert Spinner to Register value
            var result = value;
            var result = DeciTemp2RegValue_OFFSET(value);
			return result;
        }
    );


	gc.databind.registry.bind('widget.ti_widget_spinner_offset8.value','reg.RTEMP8_OFF_CONFIG.RTEMP8_OFF',
        function(value) {
            // convert register value spinner value
            var result = value;
            result = RegTemp2Deci_OFFSET(gc.databind.registry.getBinding('reg.RTEMP8_OFF_CONFIG.RTEMP8_OFF').getValue());
            return result;
        },
        function(value) {
            // Convert Spinner to Register value
            var result = value;
            var result = DeciTemp2RegValue_OFFSET(value);
			return result;
        }
    );


///////////////////////////////////////////////    
//Binding for Local temperature
	gc.databind.registry.bind('widget.ti_widget_label_settings_LTEMP.label','reg.LTEMP.LTEMP',
        function(value) {
            // convert register value to object
            var result = RegTemp2Deci(value);
            return result + " °" +tempScale;
        }
    );

//Binding for Remote temperature
	gc.databind.registry.bind('widget.ti_widget_label_settings_TEMP_CH1.label','reg.RTEMP1.RTEMP1',
        function(value) {
           var result = RegTemp2Deci(value);
            return result + " °" + tempScale;
        }
    );
    
	gc.databind.registry.bind('widget.ti_widget_label_settings_TEMP_CH2.label','reg.RTEMP2.RTEMP2',
        function(value) {
          var  result = RegTemp2Deci(value);
            return result + " °" + tempScale;
        }
    );
    
	gc.databind.registry.bind('widget.ti_widget_label_settings_TEMP_CH3.label','reg.RTEMP3.RTEMP3',
        function(value) {
         var   result = RegTemp2Deci(value);
            return result + " °" + tempScale;
        }
    );
    
	gc.databind.registry.bind('widget.ti_widget_label_settings_TEMP_CH4.label','reg.RTEMP4.RTEMP4',
        function(value) {
       var     result = RegTemp2Deci(value);
            return result + " °" + tempScale;
        }
    );
    
	gc.databind.registry.bind('widget.ti_widget_label_settings_TEMP_CH5.label','reg.RTEMP5.RTEMP5',
        function(value) {
          var  result = RegTemp2Deci(value);
            return result + " °" + tempScale;
        }
    );
    
	gc.databind.registry.bind('widget.ti_widget_label_settings_TEMP_CH6.label','reg.RTEMP6.RTEMP6',
        function(value) {
         var   result = RegTemp2Deci(value);
            return result + " °" + tempScale;
        }
    );
    
	gc.databind.registry.bind('widget.ti_widget_label_settings_TEMP_CH7.label','reg.RTEMP7.RTEMP7',
        function(value) {
         var   result = RegTemp2Deci(value);
            return result + " °" + tempScale;
        }
    );
    
	gc.databind.registry.bind('widget.ti_widget_label_settings_TEMP_CH8.label','reg.RTEMP8.RTEMP8',
        function(value) {
         var   result = RegTemp2Deci(value);
            return result + " °" + tempScale;
        }
    );
    
    
//Binding for Local Limits\\\\\\*****\\\\\\
	gc.databind.registry.bind('widget.ti_widget_slider_LTHERM2.value','reg.Local_THERM2.LTHERM2',
        function(value) {
            // convert register value to object
            var result = value;
            result = RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.Local_THERM2.LTHERM2').getValue());
            return result;
        },
                function(value) {
            // convert object value to register
            var result = value;
            result = DeciTemp2RegValue_THERM(result);
            return result;
        }
        
    );

	gc.databind.registry.bind('widget.ti_widget_slider_LTHERM.value','reg.Local_THERM.LTHERM',
        function(value) {
            // convert register value to object
            var result = value;
            result = RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.Local_THERM.LTHERM').getValue());
            return result;
        },
                function(value) {
            // convert object value to register
            var result = value;
            result = DeciTemp2RegValue_THERM(result);
            return result;
        }
        
    );

//Binding for Remote Limits\\\\\\*****\\\\\\

//THERM1 Limits
	gc.databind.registry.bind('widget.ti_widget_slider_THERM_CH1.value','reg.RTEMP1_THERM_LIMIT.RTEMP1_THERM_LIMIT',
        function(value) {
            // convert register value to object
            var result = value;
            result = RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP1_THERM_LIMIT.RTEMP1_THERM_LIMIT').getValue());
            return result;
        },
                function(value) {
            // convert object value to register
            var result = value;
            result = DeciTemp2RegValue_THERM(result);
            return result;
        }
        
    );
    
	gc.databind.registry.bind('widget.ti_widget_slider_THERM_CH2.value','reg.RTEMP2_THERM_LIMIT.RTEMP2_THERM_LIMIT',
        function(value) {
            // convert register value to object
            var result = value;
            result = RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP2_THERM_LIMIT.RTEMP2_THERM_LIMIT').getValue());
            return result;
        },
                function(value) {
            // convert object value to register
            var result = value;
            result = DeciTemp2RegValue_THERM(result);
            return result;
        }
        
    );
    
	gc.databind.registry.bind('widget.ti_widget_slider_THERM_CH3.value','reg.RTEMP3_THERM_LIMIT.RTEMP3_THERM_LIMIT',
        function(value) {
            // convert register value to object
            var result = value;
            result = RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP3_THERM_LIMIT.RTEMP3_THERM_LIMIT').getValue());
            return result;
        },
                function(value) {
            // convert object value to register
            var result = value;
            result = DeciTemp2RegValue_THERM(result);
            return result;
        }
        
    );
    
	gc.databind.registry.bind('widget.ti_widget_slider_THERM_CH4.value','reg.RTEMP4_THERM_LIMIT.RTEMP4_THERM_LIMIT',
        function(value) {
            // convert register value to object
            var result = value;
            result = RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP4_THERM_LIMIT.RTEMP4_THERM_LIMIT').getValue());
            return result;
        },
                function(value) {
            // convert object value to register
            var result = value;
            result = DeciTemp2RegValue_THERM(result);
            return result;
        }
        
    );
    
	gc.databind.registry.bind('widget.ti_widget_slider_THERM_CH5.value','reg.RTEMP5_THERM_LIMIT.RTEMP5_THERM_LIMIT',
        function(value) {
            // convert register value to object
            var result = value;
            result = RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP5_THERM_LIMIT.RTEMP5_THERM_LIMIT').getValue());
            return result;
        },
                function(value) {
            // convert object value to register
            var result = value;
            result = DeciTemp2RegValue_THERM(result);
            return result;
        }
        
    );
    
	gc.databind.registry.bind('widget.ti_widget_slider_THERM_CH6.value','reg.RTEMP6_THERM_LIMIT.RTEMP6_THERM_LIMIT',
        function(value) {
            // convert register value to object
            var result = value;
            result = RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP6_THERM_LIMIT.RTEMP6_THERM_LIMIT').getValue());
            return result;
        },
                function(value) {
            // convert object value to register
            var result = value;
            result = DeciTemp2RegValue_THERM(result);
            return result;
        }
        
    );
    
	gc.databind.registry.bind('widget.ti_widget_slider_THERM_CH7.value','reg.RTEMP7_THERM_LIMIT.RTEMP7_THERM_LIMIT',
        function(value) {
            // convert register value to object
            var result = value;
            result = RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP7_THERM_LIMIT.RTEMP7_THERM_LIMIT').getValue());
            return result;
        },
                function(value) {
            // convert object value to register
            var result = value;
            result = DeciTemp2RegValue_THERM(result);
            return result;
        }
        
    );
    
	gc.databind.registry.bind('widget.ti_widget_slider_THERM_CH8.value','reg.RTEMP8_THERM_LIMIT.RTEMP8_THERM_LIMIT',
        function(value) {
            // convert register value to object
            var result = value;
            result = RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP8_THERM_LIMIT.RTEMP8_THERM_LIMIT').getValue());
            return result;
        },
                function(value) {
            // convert object value to register
            var result = value;
            result = DeciTemp2RegValue_THERM(result);
            return result;
        }
        
    );
    

//THERM2 Limits  
    	gc.databind.registry.bind('widget.ti_widget_slider_THERM2_CH1.value','reg.RTEMP1_THERM2_LIMIT.RTEMP1_THERM2_LIMIT',
        function(value) {
            // convert register value to object
            var result = value;
            result = RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP1_THERM2_LIMIT.RTEMP1_THERM2_LIMIT').getValue());
            return result;
        },
                function(value) {
            // convert object value to register
            var result = value;
            result = DeciTemp2RegValue_THERM(result);
            return result;
        }
        
    );    
    	gc.databind.registry.bind('widget.ti_widget_slider_THERM2_CH2.value','reg.RTEMP2_THERM2_LIMIT.RTEMP2_THERM2_LIMIT',
        function(value) {
            // convert register value to object
            var result = value;
            result = RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP2_THERM2_LIMIT.RTEMP2_THERM2_LIMIT').getValue());
            return result;
        },
                function(value) {
            // convert object value to register
            var result = value;
            result = DeciTemp2RegValue_THERM(result);
            return result;
        }
        
    );    
    	gc.databind.registry.bind('widget.ti_widget_slider_THERM2_CH3.value','reg.RTEMP3_THERM2_LIMIT.RTEMP3_THERM2_LIMIT',
        function(value) {
            // convert register value to object
            var result = value;
            result = RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP3_THERM2_LIMIT.RTEMP3_THERM2_LIMIT').getValue());
            return result;
        },
                function(value) {
            // convert object value to register
            var result = value;
            result = DeciTemp2RegValue_THERM(result);
            return result;
        }
        
    );    
    	gc.databind.registry.bind('widget.ti_widget_slider_THERM2_CH4.value','reg.RTEMP4_THERM2_LIMIT.RTEMP4_THERM2_LIMIT',
        function(value) {
            // convert register value to object
            var result = value;
            result = RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP4_THERM2_LIMIT.RTEMP4_THERM2_LIMIT').getValue());
            return result;
        },
                function(value) {
            // convert object value to register
            var result = value;
            result = DeciTemp2RegValue_THERM(result);
            return result;
        }
        
    );    
    	gc.databind.registry.bind('widget.ti_widget_slider_THERM2_CH5.value','reg.RTEMP5_THERM2_LIMIT.RTEMP5_THERM2_LIMIT',
        function(value) {
            // convert register value to object
            var result = value;
            result = RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP5_THERM2_LIMIT.RTEMP5_THERM2_LIMIT').getValue());
            return result;
        },
                function(value) {
            // convert object value to register
            var result = value;
            result = DeciTemp2RegValue_THERM(result);
            return result;
        }
        
    );    
    	gc.databind.registry.bind('widget.ti_widget_slider_THERM2_CH6.value','reg.RTEMP6_THERM2_LIMIT.RTEMP6_THERM2_LIMIT',
        function(value) {
            // convert register value to object
            var result = value;
            result = RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP6_THERM2_LIMIT.RTEMP6_THERM2_LIMIT').getValue());
            return result;
        },
                function(value) {
            // convert object value to register
            var result = value;
            result = DeciTemp2RegValue_THERM(result);
            return result;
        }
        
    );
    	gc.databind.registry.bind('widget.ti_widget_slider_THERM2_CH7.value','reg.RTEMP7_THERM2_LIMIT.RTEMP7_THERM2_LIMIT',
        function(value) {
            // convert register value to object
            var result = value;
            result = RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP7_THERM2_LIMIT.RTEMP7_THERM2_LIMIT').getValue());
            return result;
        },
                function(value) {
            // convert object value to register
            var result = value;
            result = DeciTemp2RegValue_THERM(result);
            return result;
        }
        
    );
    	gc.databind.registry.bind('widget.ti_widget_slider_THERM2_CH8.value','reg.RTEMP8_THERM2_LIMIT.RTEMP8_THERM2_LIMIT',
        function(value) {
            // convert register value to object
            var result = value;
            result = RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP8_THERM2_LIMIT.RTEMP8_THERM2_LIMIT').getValue());
            return result;
        },
                function(value) {
            // convert object value to register
            var result = value;
            result = DeciTemp2RegValue_THERM(result);
            return result;
        }
        
    );
            
    
//Binding for Hysteresis vaules\\\\\\*****\\\\\\
	gc.databind.registry.bind('widget.ti_widget_slider_settings_hys1.value','reg.THERM_HYST.THERM_HYST',
        function(value) {
            // convert register value to object
            var result = value;
            result = RegTemp2Deci_HYS(gc.databind.registry.getBinding('reg.THERM_HYST.THERM_HYST').getValue(),0);
            return result;
        },
                function(value) {
            // convert object value to register
            var result = value;
            result = DeciTemp2RegValue_HYS(result);
            return result;
        }
        
    );

//Binding ti_widget_button_oneshot
	gc.databind.registry.bind('widget.ti_widget_button_oneshot.disabled','reg.CONFIG_REG.SD',
        function(value) {
            // convert register value to object
            var result = !value;
            return result;
        }
    );
    });
            

/*
 *  Boilerplate code for creating custom actions
 */
document.addEventListener('gc-nav-ready', function() {
    /*
     *   Add custom actions for menu items using the following api:
     *
     *   function gc.nav.registryAction(id, runable, [isAvailable], [isVisible]);
     *
     *   param id - uniquely identifies the action, and should correspond to the action property of the menuaction widget.
     *   param runable - function that performs the custom action.
     *   param isAvailable - (optional) - function called when the menu action is about to appear.  Return false to disable the action, or true to enable it.
     *   param isVisible - (optional) - function called when the menu action is about to appear.  Return false to hide the action, or true to make it visible.
     */

    // For example,
    // gc.nav.registerAction('myCustomCloseAction', function() { window.close(); }, function() { return true; }, function() { return true; });

    // Alternatively, to programmatically disable a menu action at any time use:
    // gc.nav.disableAction('myCustomCloseAction);    then enable it again using:  gc.nav.enableAction('myCustomCloseAction');

    gc.nav.registerAction('show_introduction', function() {
        if ((templateObj) && (templateObj.$)) {
            templateObj.$.ti_widget_vtabcontainer.selectedIndex = 0;
            templateObj.$.ti_widget_menuitem.hideFullMenu();
        }
    }, function() {
        return true;
    }, function() {
        return true;
    });
    gc.nav.registerAction('show_registers', function() {
        if ((templateObj) && (templateObj.$)) {
            templateObj.$.ti_widget_vtabcontainer.selectedIndex = 1;
            templateObj.$.ti_widget_menuitem.hideFullMenu();
        }
    }, function() {
        return true;
    }, function() {
        return true;
    });
    gc.nav.registerAction('show_motor_control', function() {
        if ((templateObj) && (templateObj.$)) {
            templateObj.$.ti_widget_vtabcontainer.selectedIndex = 2;
            templateObj.$.ti_widget_menuitem.hideFullMenu();
        }
    }, function() {
        return true;
    }, function() {
        return true;
    });

    gc.nav.registerAction('load_registers', function() {
        if ((templateObj) && (templateObj.$)) {
            gc.File.browseAndLoad(null, {
                bin: false
            }, function(contents, properties) {
                var regData = null;
                try {
                    regData = JSON.parse(contents);
                    if (regData) {
                        templateObj.setRegisterData(regData);
                        templateObj.$.ti_widget_eventlog_view.log("info", "Load Registers: loaded from :" + properties.localPath);
                    }
                } catch (ex) {
                    templateObj.logMsgAndNotify("error", "Load Registers: Could not parse file:" + ex, false, true);
                }

            });
        }
    }, function() {
        return true;
    }, function() {
        return true;
    });

    var saveText = function(fname, text, mime) {
        var blob = new Blob([text], {
            type: mime
        });
        saveAs(blob, fname);
        return false;
    }

    var saveRegsAs = function(calledBy, regDataJson) {
        gc.File.browseAndSave(regDataJson, 'regs.json', '.json', function(result, errorInfo) {
            if (errorInfo) {
                templateObj.logMsgAndNotify("error", calledBy + " " + errorInfo, false, true);
            } else if ((result) && (result.localPath)) {
                saveAsFilePath = result.localPath;
                templateObj.$.ti_widget_eventlog_view.log("info", "Registers saved to " + result.localPath);
            }
        });
    }

    gc.nav.registerAction('save_registers', function() {
        if ((templateObj) && (templateObj.$)) {
            var regData = templateObj.getRegisterData();
            var regDataJson = JSON.stringify(regData);
            if (gc.desktop.isDesktop()) {
                if (!saveAsFilePath) {
                    saveRegsAs("Save Registers", regDataJson);
                } else {
                    gc.File.save(regDataJson, {"localPath": saveAsFilePath}, null, function(errorInfo) {
                        if (errorInfo) {
                            templateObj.logMsgAndNotify("error", "Save Registers As: " + errorInfo, false, true);
                        } else {
                            templateObj.$.ti_widget_eventlog_view.log("info", "Registers saved to " + saveAsFilePath);
                        }
                    });
                }

            } else {
                saveText("regs.json", regDataJson, 'text/plain;charset=utf-8')
                templateObj.$.ti_widget_eventlog_view.log("info", "Save Registers: regs.json file downloaded");
            }
        }
    }, function() {
        return true;
    }, function() {
        return true;
    });

    gc.nav.registerAction('save_registers_as', function() {
        if ((templateObj) && (templateObj.$)) {
            var regData = templateObj.getRegisterData();
            var regDataJson = JSON.stringify(regData);
            if (gc.desktop.isDesktop()) {
                saveRegsAs("Save Registers As", regDataJson);
            } else {
                saveText("regs.json", regDataJson, 'text/plain;charset=utf-8')
                templateObj.$.ti_widget_eventlog_view.log("info", "Save Registers As: regs.json file downloaded");
            }
        }
    }, function() {
        return true;
    }, function() {
        return true;
    });

    gc.nav.registerAction('open_log_pane', function() {
        if ((templateObj) && (templateObj.$)) {
            templateObj.$.ti_widget_eventlog_view.openView();
        }
    }, function() {
        return true;
    }, function() {
        return true;
    });

    gc.nav.registerAction('open_scripting_window', function() {
        window.open('app/scripting.html', '_evm_scripting');
    }, function() {
        return true;
    }, function() {
        return true;
    });
});

/*
 *  Boilerplate code for working with components in the application gist
 */


var initComplete = false;
var templateObj;
var registerModel;


// Wait for DOMContentLoaded event before trying to access the application template
var init = function() {
    templateObj = document.querySelector('#template_obj');

    // Wait for the template to fire a dom-change event to indicate that it has been 'stamped'
    // before trying to access components in the application.
    templateObj.addEventListener('dom-change', function() {
        if (initComplete) return;
        this.async(function() {
            initComplete = true;
            console.log("Application template has been stamped.");
            templateObj.$.ti_widget_toast.hideToast();
            templateObj.$.ti_widget_eventlog_view.log("info", "Application started.");
            registerModel = Polymer.dom(document).querySelector('ti-model-register');
            if (registerModel) {
                registerModel.addEventListener("usbHidModelReceivingData", function (event) {
                    templateObj.logMsgAndNotify("debug", "Receiving data from target.", false, false);
                });
            } else {
                console.log("no ti-model-register component found in this application!")
            }

            // Now that the template has been stamped, you can use 'automatic node finding' $ syntax to access widgets.
            // e.g. to access a widget with an id of 'widget_id' you can use templateObj.$.widgetId
           
            if (templateObj.$.ti_widget_tabcontainer_guide) {
                templateObj.$.ti_widget_tabcontainer_guide.selectedIndex = 0; // always start with the home page

                templateObj.$.ti_widget_label_expert.addEventListener("click", function(event) {
                    templateObj.$.ti_widget_vtabcontainer.selectedIndex = 3;
                });

                templateObj.$.ti_widget_label_beginner.addEventListener("click", function(event) {
                    templateObj.$.ti_widget_tabcontainer_guide.selectedIndex = 1;
                });

                templateObj.skipPage = function() {
                    templateObj.$.ti_widget_tabcontainer_guide.selectedIndex = 1 + templateObj.$.ti_widget_tabcontainer_guide.selectedIndex;
                };
                
                templateObj.$.ti_widget_button_config_settngs.addEventListener("click", function(event) {
                    templateObj.$.ti_widget_tabcontainer_guide.selectedIndex = 2;
                });    
                
                templateObj.$.ti_widget_label_guide2_basic.addEventListener("click", function(event) {
                    templateObj.$.ti_widget_tabcontainer_guide.selectedIndex = 3;
                });    
                

                templateObj.$.ti_widget_button_go2plots.addEventListener("click", function(event) {
                    templateObj.$.ti_widget_vtabcontainer.selectedIndex = 3;
                });

                
                templateObj.$.ti_widget_button_basic_plots.addEventListener("click", function(event) {
                    templateObj.$.ti_widget_vtabcontainer.selectedIndex = 3;
                });

                templateObj.$.ti_widget_button_basic_yes_fullsettings.addEventListener("click", function(event) {
                    templateObj.$.ti_widget_vtabcontainer.selectedIndex = 2;
                });                
                
                 templateObj.$.ti_widget_button_HW_No.addEventListener("click", function(event) {
                    templateObj.$.ti_widget_tabcontainer_guide.selectedIndex = 5;
                });               
                
                 templateObj.$.ti_widget_button_ts_goback.addEventListener("click", function(event) {
                    templateObj.$.ti_widget_tabcontainer_guide.selectedIndex = 1;
                });
    
                templateObj.$.ti_widget_button_HW_Yes.addEventListener("click", function(event) {
                     templateObj.$.ti_widget_tabcontainer_guide.selectedIndex = 3;
                });  

                

                templateObj.$.ti_widget_label_skip_page.addEventListener("click", templateObj.skipPage);

		// when the user changes the vtab, reset the guide back to its first page
                templateObj.$.ti_widget_vtabcontainer.addEventListener("selected_tab_changed", function(event) {
                    if (templateObj.$.ti_widget_vtabcontainer === 1) {
                        // reset the guide back to the first tab
                        templateObj.$.ti_widget_tabcontainer_guide.selectedIndex = 0;
                    }
                });
            }
            // open the eventlog viewer when the user clicks on the book icon in the status bar:
            templateObj.$.ti_widget_eventlog_view.closeView(); // ensure that view states are in sync with application
            templateObj.$.ti_widget_statusbar.addEventListener("appiconclicked", function(event) {
                templateObj.$.ti_widget_eventlog_view.toggleView();
            });

    
            // Expand vtabcontainer nav bar when user clicks on menu icon or 'Menu' label
            templateObj.toggleMenu = function(event){
                templateObj.$.ti_widget_vtabcontainer.isExpanded = !templateObj.$.ti_widget_vtabcontainer.isExpanded;
            };
            templateObj.$.ti_widget_icon_button_menu.addEventListener('click',templateObj.toggleMenu);
            templateObj.$.ti_widget_label_menu.addEventListener('click',templateObj.toggleMenu);

            if (templateObj.$.ti_widget_register_page) {
                // get the active device name from the register page
                templateObj.$.ti_widget_menubar.productName = templateObj.$.ti_widget_register_page.deviceName;

                // called when the user clicks the Write Register button:
                templateObj.$.ti_widget_register_page.addEventListener("write_reg", function (event) {
                    var detailsObj = event.detail;
                    templateObj.logMsgAndNotify(detailsObj.statusType, detailsObj.statusMsg, false, true);
                }.bind(this));

                // called when the user clicks the Write All Registers button:
                templateObj.$.ti_widget_register_page.addEventListener("write_regs", function (event) {
                    var detailsObj = event.detail;
                    templateObj.logMsgAndNotify(detailsObj.statusType, detailsObj.statusMsg, false, true);
                }.bind(this));

                // called when the user clicks the Read Register button:
                templateObj.$.ti_widget_register_page.addEventListener("read_reg", function (event) {
                    var detailsObj = event.detail;
                    templateObj.logMsgAndNotify(detailsObj.statusType, detailsObj.statusMsg, false, true);
                }.bind(this));

                // called when the user clicks the Read All Registers button:
                templateObj.$.ti_widget_register_page.addEventListener("read_regs", function (event) {
                    var detailsObj = event.detail;
                    templateObj.logMsgAndNotify(detailsObj.statusType, detailsObj.statusMsg, false, true);
                }.bind(this));

                // called when the user changes the immediate / deferred mode
                templateObj.$.ti_widget_register_page.addEventListener("update_mode_changed", function (event) {
                    var detailsObj = event.detail;
                    templateObj.$.ti_widget_eventlog_view.log("info", "request to change update mode to " + detailsObj.mode.label);
                }.bind(this));

                // called when the user changes the auto read refresh rate
                templateObj.$.ti_widget_register_page.addEventListener("auto_read_config_changed", function (event) {
                    var detailsObj = event.detail;
                    templateObj.$.ti_widget_eventlog_view.log("info", "request to change automatic read interval to " + detailsObj.autoRead.label);
                }.bind(this));
            }

            var usbHidService = gc.services['ti-service-usbhid'];
            if (usbHidService) {
                usbHidService.addEventListener('usbHidError', function(event) {
                    var detailsObj = event.detail;
                    templateObj.logMsgAndNotify("error", detailsObj.info + ": " + detailsObj.error, false, true);
                })
            }
            templateObj.getRegisterData = function() {
                var regData = {
                    signature: "oneui-register-data",
                    data: []
                }
                var regBlocks = templateObj.$.ti_widget_register_page.regBlocks;
                for (var i = 0; i < regBlocks.length; i++) {
                    var registersData = [];
                    for (var r = 0; r < regBlocks[i].registers.length; r++) {
                        var reg = regBlocks[i].registers[r];
                        var regName = reg.name.toLowerCase();
                        regName = regName.replace(/\&/g, "_");
                        var item = {
                            idx: r,
                            id: regName,
                            value: reg.value
                        }
                        registersData.push(item);
                    }
                    regData.data.push(registersData);
                }
                var strJson = JSON.stringify(regData);
                return strJson;
            };

            templateObj.setRegisterData = function(strJson) {
                var regData = JSON.parse(strJson);
                var ok = true;
                var regBlocks = templateObj.$.ti_widget_register_page._registerView.regBlocks;
                for (var b = 0; b < regBlocks.length; b++) {
                    var registersData = [];
                    for (var r = 0; r < regBlocks[b].registers.length; r++) {
                        var reg = regBlocks[b].registers[r];
                        var regName = reg.name.toLowerCase();
                        regName = regName.replace(/\&/g, "_");
                        item = regData.data[b][r];
                        if (item.id === regName) {
                            reg.value = item.value;
                            if (!templateObj.$.ti_widget_register_page.isDeferredWrite) {
                                reg.valueLastWritten = reg.value;
                                var intValue = gc.utils.getValueFromHexString("" + reg.value);
                                templateObj.$.ti_widget_register_page.writeValueToTargetRegister(intValue, null, b, r);
                            } else {
                                templateObj.$.ti_widget_register_page._registerView.refreshRegValue(b,r);
                            }
                        } else {
                            var msg = "load registers failed: register name mismatch (" + item.id + " does not match " + regName + ")";
                            templateObj.logMsgAndNotify("warning", msg, false, true);
                        }
                    }
                }
                if (templateObj.$.ti_widget_register_page.isDeferredWrite){
                    templateObj.$.ti_widget_register_page._registerView._deferredAccessCtr++; // update the page
                }
            };

            templateObj.showToastMsg = function(msgType, msg, durationInSeconds) {
                templateObj.$.ti_widget_toast.hideToast();
                templateObj.$.ti_widget_toast.message = msg;
                switch (msgType.toLowerCase()) {
                    case "error":
                        templateObj.$.ti_widget_toast.iconName = "error";
                        templateObj.$.ti_widget_toast.backgroundColor = "red";
                        break;
                    case "warning":
                        templateObj.$.ti_widget_toast.iconName = "warning";
                        templateObj.$.ti_widget_toast.backgroundColor = "orange";
                        break;
                    default:
                        templateObj.$.ti_widget_toast.iconName = "check";
                        templateObj.$.ti_widget_toast.backgroundColor = "teal";
                        break;
                }
                templateObj.$.ti_widget_toast.duration = +durationInSeconds;
                templateObj.$.ti_widget_toast.showToast();
                console.log("toast msg [" + msgType + "]: " + msg);
            };

            templateObj.logMsgAndNotify = function(msgType, msg, showInStatusBar, showInToast) {
                var iconName = templateObj.$.ti_widget_eventlog_view.iconForItem(msgType);
                if (showInStatusBar) {
                    var statusBar = gc.services['ti-widget-statusbar'];
                    if (statusBar) {
                        statusBar.statusString3 = msg;
                        statusBar.setIcon(iconName);
                    }
                }
                if (showInToast) {
                    templateObj.showToastMsg(msgType, msg, 4);
                }
                templateObj.$.ti_widget_eventlog_view.log(msgType, msg);
            };
            templateObj.$.ti_widget_label_learnmore.addEventListener("click",function(event){
                 //templateObj.$.ti_widget_label_productname.fontColor="#444";
                 templateObj.$.ti_widget_label_productdesc.fontColor="#444";
                 templateObj.$.ti_widget_label_learnmore.setAttribute('hidden',true);
                 templateObj.$.ti_widget_label_showless.removeAttribute('hidden');
                 //templateObj.$.ti_widget_vtab_home.style.backgroundColor = "white";
                 templateObj.$.ti_widget_tabcontainer.selectedIndex = 1;
            });
            templateObj.$.ti_widget_label_showless.addEventListener("click",function(event){
                 templateObj.$.ti_widget_label_productname.fontColor="white";
                 templateObj.$.ti_widget_label_productdesc.fontColor="white";
                 templateObj.$.ti_widget_label_learnmore.removeAttribute('hidden');
                 templateObj.$.ti_widget_label_showless.setAttribute('hidden',true);
                 templateObj.$.ti_widget_vtab_home.style.backgroundColor = "rgb(20, 140, 156)";
                 templateObj.$.ti_widget_tabcontainer.selectedIndex = 0;
            });
///////My Code////
            //Set I2C Address
			gc.databind.registry.bind('ti_widget_droplist_I2C_address.selectedValue','reg.$deviceAddrs');

            //Set I2C Frequency based on droplist
            templateObj.$.ti_widget_droplist2_i2c_freq.addEventListener("selected", function(event) {
               var u2a= document.querySelector('ti-model-register').getCodec();         // get codec
               var Cmd_I2C_Set = 1;                                                     // Command to set I2C port
               var speed = templateObj.$.ti_widget_droplist2_i2c_freq.selectedIndex;    // Speed based on droplist index: 0:100kHz, 1:400kHz, 2:10kHz
               var commandSent = u2a.sendCommandPacket(Cmd_I2C_Set, [speed, 0, 1])      // send command to set I2C, see packet definition in USB2ANY.h
            });
            
            //Implement I2C Reset
            templateObj.$.ti_widget_button_I2C_reset.addEventListener("click", function(event) {
    			var bind = gc.databind.registry.getBinding('reg.RESET.RST');
		         bind.setValue(1);
		         bind = gc.databind.registry.getBinding('reg.LOCK.LOCK');
            				bind.setValue(60185);
            }); 
            templateObj.updateTempScale = function() {
                var origScale = tempScale;
                var labels;
                var inc;
                var max;
                var min;
                var max_off;
                var min_off;
                var max_hys;
                var min_hys;
                var inc_hys;
                var labels_hys;
                
                if (ti_widget_radio_group_datacap_CF.selectedText.toLowerCase() === "fahrenheit") {
                    tempScale = "F";
                    max = 375.8;
                    min = -83.2;                
                    max_off = 228.6;
                    min_off = -230.4;                
                    max_hys = 228.6;
                    min_hys = 0;
                    inc_hys = 1.8;
                    labels_hys = '0,57.6,115.2,172.8,228.6';
                    labels = F_Slider_labels_standard;
                } else {
                    tempScale = "C";
                    max = C_Range_high_standard;
                    min = -64;
                    max_off = 127.9375;
                    min_off = -128;
                    max_hys = 127;
                    min_hys = 0;
                    inc_hys = 1;
                    labels_hys = '0,16,32,48,64,80,96,112,127';
                    labels = C_Slider_labels_standard
                }
                if (origScale !== tempScale) {
                    //settings readings
                   templateObj.$.ti_widget_label_settings_LTEMP.label = RegTemp2Deci(gc.databind.registry.getBinding('reg.LTEMP.LTEMP').getValue())+ " °" + tempScale;
                   templateObj.$.ti_widget_label_settings_TEMP_CH1.label = RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP1.RTEMP1').getValue())+ " °" + tempScale;
                   templateObj.$.ti_widget_label_settings_TEMP_CH2.label = RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP2.RTEMP2').getValue())+ " °" + tempScale;
                   templateObj.$.ti_widget_label_settings_TEMP_CH3.label = RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP3.RTEMP3').getValue())+ " °" + tempScale;
                   templateObj.$.ti_widget_label_settings_TEMP_CH4.label = RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP4.RTEMP4').getValue())+ " °" + tempScale;
                   templateObj.$.ti_widget_label_settings_TEMP_CH5.label = RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP5.RTEMP5').getValue())+ " °" + tempScale;
                   templateObj.$.ti_widget_label_settings_TEMP_CH6.label = RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP6.RTEMP6').getValue())+ " °" + tempScale;
                   templateObj.$.ti_widget_label_settings_TEMP_CH7.label = RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP7.RTEMP7').getValue())+ " °" + tempScale;
                   templateObj.$.ti_widget_label_settings_TEMP_CH8.label = RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP8.RTEMP8').getValue())+ " °" + tempScale;
					//datacap readings
                   templateObj.$.ti_widget_label_datacap_LTEMP.label = RegTemp2Deci(gc.databind.registry.getBinding('reg.LTEMP.LTEMP').getValue())+ " °" + tempScale;
                   templateObj.$.ti_widget_label_datacap_TEMP_CH1.label = RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP1.RTEMP1').getValue())+ " °" + tempScale;
                   templateObj.$.ti_widget_label_datacap_TEMP_CH2.label = RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP2.RTEMP2').getValue())+ " °" + tempScale;
                   templateObj.$.ti_widget_label_datacap_TEMP_CH3.label = RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP3.RTEMP3').getValue())+ " °" + tempScale;
                   templateObj.$.ti_widget_label_datacap_TEMP_CH4.label = RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP4.RTEMP4').getValue())+ " °" + tempScale;
                   templateObj.$.ti_widget_label_datacap_TEMP_CH5.label = RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP5.RTEMP5').getValue())+ " °" + tempScale;
                   templateObj.$.ti_widget_label_datacap_TEMP_CH6.label = RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP6.RTEMP6').getValue())+ " °" + tempScale;
                   templateObj.$.ti_widget_label_datacap_TEMP_CH7.label = RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP7.RTEMP7').getValue())+ " °" + tempScale;
                   templateObj.$.ti_widget_label_datacap_TEMP_CH8.label = RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP8.RTEMP8').getValue())+ " °" + tempScale;
					
					
					
					
					//settings page
					templateObj.$.ti_widget_slider_LTHERM.labels = labels;
                    templateObj.$.ti_widget_slider_LTHERM2.labels = labels;
					templateObj.$.ti_widget_slider_THERM_CH1.labels = labels;
                    templateObj.$.ti_widget_slider_THERM2_CH1.labels = labels;
					templateObj.$.ti_widget_slider_THERM_CH2.labels = labels;
                    templateObj.$.ti_widget_slider_THERM2_CH2.labels = labels;
					templateObj.$.ti_widget_slider_THERM_CH3.labels = labels;
                    templateObj.$.ti_widget_slider_THERM2_CH3.labels = labels;
					templateObj.$.ti_widget_slider_THERM_CH4.labels = labels;
                    templateObj.$.ti_widget_slider_THERM2_CH4.labels = labels;
					templateObj.$.ti_widget_slider_THERM_CH5.labels = labels;
                    templateObj.$.ti_widget_slider_THERM2_CH5.labels = labels;
					templateObj.$.ti_widget_slider_THERM_CH6.labels = labels;
                    templateObj.$.ti_widget_slider_THERM2_CH6.labels = labels;
					templateObj.$.ti_widget_slider_THERM_CH7.labels = labels;
                    templateObj.$.ti_widget_slider_THERM2_CH7.labels = labels;
					templateObj.$.ti_widget_slider_THERM_CH8.labels = labels;
                    templateObj.$.ti_widget_slider_THERM2_CH8.labels = labels;
                    templateObj.$.ti_widget_slider_settings_hys1.labels = labels_hys;
                    
                    //Data cap 
					templateObj.$.ti_widget_slider_LTHERM_datacap.labels = labels;
					templateObj.$.ti_widget_slider_LTHERM2_datacap.labels = labels;
					templateObj.$.ti_widget_slider_datacap_THERM_CH1.labels = labels;
					templateObj.$.ti_widget_slider_datacap_THERM2_CH1.labels = labels;					
					templateObj.$.ti_widget_slider_datacap_THERM_CH2.labels = labels;
					templateObj.$.ti_widget_slider_datacap_THERM2_CH2.labels = labels;					
					templateObj.$.ti_widget_slider_datacap_THERM_CH3.labels = labels;
					templateObj.$.ti_widget_slider_datacap_THERM2_CH3.labels = labels;					
					templateObj.$.ti_widget_slider_datacap_THERM_CH4.labels = labels;
					templateObj.$.ti_widget_slider_datacap_THERM2_CH4.labels = labels;					
					templateObj.$.ti_widget_slider_datacap_THERM_CH5.labels = labels;
					templateObj.$.ti_widget_slider_datacap_THERM2_CH5.labels = labels;					
					templateObj.$.ti_widget_slider_datacap_THERM_CH6.labels = labels;
					templateObj.$.ti_widget_slider_datacap_THERM2_CH6.labels = labels;					
					templateObj.$.ti_widget_slider_datacap_THERM_CH7.labels = labels;
					templateObj.$.ti_widget_slider_datacap_THERM2_CH7.labels = labels;					
					templateObj.$.ti_widget_slider_datacap_THERM_CH8.labels = labels;
					templateObj.$.ti_widget_slider_datacap_THERM2_CH8.labels = labels;					
//////////////////////////////////////increment value update					
					
					//settings page
					templateObj.$.ti_widget_slider_LTHERM.increment = inc_hys/2;
                    templateObj.$.ti_widget_slider_LTHERM2.increment = inc_hys/2;
					templateObj.$.ti_widget_slider_THERM_CH1.increment = inc_hys/2;
                    templateObj.$.ti_widget_slider_THERM2_CH1.increment = inc_hys/2;
					templateObj.$.ti_widget_slider_THERM_CH2.increment = inc_hys/2;
                    templateObj.$.ti_widget_slider_THERM2_CH2.increment = inc_hys/2;
					templateObj.$.ti_widget_slider_THERM_CH3.increment = inc_hys/2;
                    templateObj.$.ti_widget_slider_THERM2_CH3.increment = inc_hys/2;
					templateObj.$.ti_widget_slider_THERM_CH4.increment = inc_hys/2;
                    templateObj.$.ti_widget_slider_THERM2_CH4.increment = inc_hys/2;
					templateObj.$.ti_widget_slider_THERM_CH5.increment = inc_hys/2;
                    templateObj.$.ti_widget_slider_THERM2_CH5.increment = inc_hys/2;
					templateObj.$.ti_widget_slider_THERM_CH6.increment = inc_hys/2;
                    templateObj.$.ti_widget_slider_THERM2_CH6.increment = inc_hys/2;
					templateObj.$.ti_widget_slider_THERM_CH7.increment = inc_hys/2;
                    templateObj.$.ti_widget_slider_THERM2_CH7.increment = inc_hys/2;
					templateObj.$.ti_widget_slider_THERM_CH8.increment = inc_hys/2;
                    templateObj.$.ti_widget_slider_THERM2_CH8.increment = inc_hys/2;
                    templateObj.$.ti_widget_slider_settings_hys1.increment = inc_hys;
                    
                    //Data cap 
					templateObj.$.ti_widget_slider_LTHERM_datacap.increment = inc_hys;
					templateObj.$.ti_widget_slider_LTHERM2_datacap.increment = inc_hys;
					templateObj.$.ti_widget_slider_datacap_THERM_CH1.increment = inc_hys;
					templateObj.$.ti_widget_slider_datacap_THERM2_CH1.increment = inc_hys;					
					templateObj.$.ti_widget_slider_datacap_THERM_CH2.increment = inc_hys;
					templateObj.$.ti_widget_slider_datacap_THERM2_CH2.increment = inc_hys;					
					templateObj.$.ti_widget_slider_datacap_THERM_CH3.increment = inc_hys;
					templateObj.$.ti_widget_slider_datacap_THERM2_CH3.increment = inc_hys;					
					templateObj.$.ti_widget_slider_datacap_THERM_CH4.increment = inc_hys;
					templateObj.$.ti_widget_slider_datacap_THERM2_CH4.increment = inc_hys;					
					templateObj.$.ti_widget_slider_datacap_THERM_CH5.increment = inc_hys;
					templateObj.$.ti_widget_slider_datacap_THERM2_CH5.increment = inc_hys;					
					templateObj.$.ti_widget_slider_datacap_THERM_CH6.increment = inc_hys;
					templateObj.$.ti_widget_slider_datacap_THERM2_CH6.increment = inc_hys;					
					templateObj.$.ti_widget_slider_datacap_THERM_CH7.increment = inc_hys;
					templateObj.$.ti_widget_slider_datacap_THERM2_CH7.increment = inc_hys;					
					templateObj.$.ti_widget_slider_datacap_THERM_CH8.increment = inc_hys;
					templateObj.$.ti_widget_slider_datacap_THERM2_CH8.increment = inc_hys;					
                    //Max Values
                    //settings page
					templateObj.$.ti_widget_slider_LTHERM.maxValue = max;
                    templateObj.$.ti_widget_slider_LTHERM2.maxValue = max;
					templateObj.$.ti_widget_slider_THERM_CH1.maxValue = max;
                    templateObj.$.ti_widget_slider_THERM2_CH1.maxValue = max;
					templateObj.$.ti_widget_slider_THERM_CH2.maxValue = max;
                    templateObj.$.ti_widget_slider_THERM2_CH2.maxValue = max;
					templateObj.$.ti_widget_slider_THERM_CH3.maxValue = max;
                    templateObj.$.ti_widget_slider_THERM2_CH3.maxValue = max;
					templateObj.$.ti_widget_slider_THERM_CH4.maxValue = max;
                    templateObj.$.ti_widget_slider_THERM2_CH4.maxValue = max;
					templateObj.$.ti_widget_slider_THERM_CH5.maxValue = max;
                    templateObj.$.ti_widget_slider_THERM2_CH5.maxValue = max;
					templateObj.$.ti_widget_slider_THERM_CH6.maxValue = max;
                    templateObj.$.ti_widget_slider_THERM2_CH6.maxValue = max;
					templateObj.$.ti_widget_slider_THERM_CH7.maxValue = max;
                    templateObj.$.ti_widget_slider_THERM2_CH7.maxValue = max;
					templateObj.$.ti_widget_slider_THERM_CH8.maxValue = max;
                    templateObj.$.ti_widget_slider_THERM2_CH8.maxValue = max;
                    templateObj.$.ti_widget_slider_settings_hys1.maxValue = max_hys;
                    
                    //Data cap 
					templateObj.$.ti_widget_slider_LTHERM_datacap.maxValue = max;
					templateObj.$.ti_widget_slider_LTHERM2_datacap.maxValue = max;
					templateObj.$.ti_widget_slider_datacap_THERM_CH1.maxValue = max;
					templateObj.$.ti_widget_slider_datacap_THERM2_CH1.maxValue = max;					
					templateObj.$.ti_widget_slider_datacap_THERM_CH2.maxValue = max;
					templateObj.$.ti_widget_slider_datacap_THERM2_CH2.maxValue = max;					
					templateObj.$.ti_widget_slider_datacap_THERM_CH3.maxValue = max;
					templateObj.$.ti_widget_slider_datacap_THERM2_CH3.maxValue = max;					
					templateObj.$.ti_widget_slider_datacap_THERM_CH4.maxValue = max;
					templateObj.$.ti_widget_slider_datacap_THERM2_CH4.maxValue = max;					
					templateObj.$.ti_widget_slider_datacap_THERM_CH5.maxValue = max;
					templateObj.$.ti_widget_slider_datacap_THERM2_CH5.maxValue = max;					
					templateObj.$.ti_widget_slider_datacap_THERM_CH6.maxValue = max;
					templateObj.$.ti_widget_slider_datacap_THERM2_CH6.maxValue = max;					
					templateObj.$.ti_widget_slider_datacap_THERM_CH7.maxValue = max;
					templateObj.$.ti_widget_slider_datacap_THERM2_CH7.maxValue = max;					
					templateObj.$.ti_widget_slider_datacap_THERM_CH8.maxValue = max;
					templateObj.$.ti_widget_slider_datacap_THERM2_CH8.maxValue = max;
					
					//Min Values
                    //settings page
					templateObj.$.ti_widget_slider_LTHERM.minValue = min;
                    templateObj.$.ti_widget_slider_LTHERM2.minValue = min;
					templateObj.$.ti_widget_slider_THERM_CH1.minValue = min;
                    templateObj.$.ti_widget_slider_THERM2_CH1.minValue = min;
					templateObj.$.ti_widget_slider_THERM_CH2.minValue = min;
                    templateObj.$.ti_widget_slider_THERM2_CH2.minValue = min;
					templateObj.$.ti_widget_slider_THERM_CH3.minValue = min;
                    templateObj.$.ti_widget_slider_THERM2_CH3.minValue = min;
					templateObj.$.ti_widget_slider_THERM_CH4.minValue = min;
                    templateObj.$.ti_widget_slider_THERM2_CH4.minValue = min;
					templateObj.$.ti_widget_slider_THERM_CH5.minValue = min;
                    templateObj.$.ti_widget_slider_THERM2_CH5.minValue = min;
					templateObj.$.ti_widget_slider_THERM_CH6.minValue = min;
                    templateObj.$.ti_widget_slider_THERM2_CH6.minValue = min;
					templateObj.$.ti_widget_slider_THERM_CH7.minValue = min;
                    templateObj.$.ti_widget_slider_THERM2_CH7.minValue = min;
					templateObj.$.ti_widget_slider_THERM_CH8.minValue = min;
                    templateObj.$.ti_widget_slider_THERM2_CH8.min = min;
                    
                    //Data cap 
					templateObj.$.ti_widget_slider_LTHERM_datacap.minValue = min;
					templateObj.$.ti_widget_slider_LTHERM2_datacap.minValue = min;
					templateObj.$.ti_widget_slider_datacap_THERM_CH1.minValue = min;
					templateObj.$.ti_widget_slider_datacap_THERM2_CH1.minValue = min;					
					templateObj.$.ti_widget_slider_datacap_THERM_CH2.minValue = min;
					templateObj.$.ti_widget_slider_datacap_THERM2_CH2.minValue = min;					
					templateObj.$.ti_widget_slider_datacap_THERM_CH3.minValue = min;
					templateObj.$.ti_widget_slider_datacap_THERM2_CH3.minValue = min;					
					templateObj.$.ti_widget_slider_datacap_THERM_CH4.minValue = min;
					templateObj.$.ti_widget_slider_datacap_THERM2_CH4.minValue = min;					
					templateObj.$.ti_widget_slider_datacap_THERM_CH5.minValue = min;
					templateObj.$.ti_widget_slider_datacap_THERM2_CH5.minValue = min;					
					templateObj.$.ti_widget_slider_datacap_THERM_CH6.minValue = min;
					templateObj.$.ti_widget_slider_datacap_THERM2_CH6.minValue = min;					
					templateObj.$.ti_widget_slider_datacap_THERM_CH7.minValue = min;
					templateObj.$.ti_widget_slider_datacap_THERM2_CH7.minValue = min;					
					templateObj.$.ti_widget_slider_datacap_THERM_CH8.minValue = min;
					templateObj.$.ti_widget_slider_datacap_THERM2_CH8.minValue = min;
					
					
					
					
                    //Offset spinner
                    templateObj.$.ti_widget_spinner_offset1.minValue = min_off;
                    templateObj.$.ti_widget_spinner_offset1.maxValue = max_off;
                    templateObj.$.ti_widget_spinner_offset1.increment = inc_hys;
                    templateObj.$.ti_widget_spinner_offset2.minValue = min_off;
                    templateObj.$.ti_widget_spinner_offset2.maxValue = max_off;
                    templateObj.$.ti_widget_spinner_offset2.increment = inc_hys;
                    templateObj.$.ti_widget_spinner_offset3.minValue = min_off;
                    templateObj.$.ti_widget_spinner_offset3.maxValue = max_off;
                    templateObj.$.ti_widget_spinner_offset3.increment = inc_hys;
                    templateObj.$.ti_widget_spinner_offset4.minValue = min_off;
                    templateObj.$.ti_widget_spinner_offset4.maxValue = max_off;
                    templateObj.$.ti_widget_spinner_offset4.increment = inc_hys;
                    templateObj.$.ti_widget_spinner_offset5.minValue = min_off;
                    templateObj.$.ti_widget_spinner_offset5.maxValue = max_off;
                    templateObj.$.ti_widget_spinner_offset5.increment = inc_hys;
                    templateObj.$.ti_widget_spinner_offset6.minValue = min_off;
                    templateObj.$.ti_widget_spinner_offset6.maxValue = max_off;
                    templateObj.$.ti_widget_spinner_offset6.increment = inc_hys;
                    templateObj.$.ti_widget_spinner_offset7.minValue = min_off;
                    templateObj.$.ti_widget_spinner_offset7.maxValue = max_off;
                    templateObj.$.ti_widget_spinner_offset7.increment = inc_hys;
                    templateObj.$.ti_widget_spinner_offset8.minValue = min_off;
                    templateObj.$.ti_widget_spinner_offset8.maxValue = max_off;
                    templateObj.$.ti_widget_spinner_offset8.increment = inc_hys;

                    
                    unitupdate(tempScale);
                }

            };
   
            templateObj.updateTempScale();
            
            templateObj.$.ti_widget_radio_group_datacap_CF.addEventListener("changed", function(event) {
                templateObj.updateTempScale();
            });	
               
			templateObj.$.ti_widget_button_oneshot.addEventListener("click", function(event) {
					var bind = gc.databind.registry.getBinding('reg.CONFIG_REG.OS');
					         bind.setValue(1);
					    bind = gc.databind.registry.getBinding('reg.CONFIG_REG.OS');
					         bind.setValue(0);
                    
                    // var u2a= document.querySelector('ti-model-register').getCodec();
                    // var Cmd_I2C_Read = 0x64;
                    					
                    templateObj.$.ti_widget_register_page.readAllRegistersClickHdlr();
                        //Temperatures
                         THYS = RegTemp2Deci_HYS(gc.databind.registry.getBinding('reg.THERM_HYST.THERM_HYST').getValue());
                         R1_Temp_data =  RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP1.RTEMP1').getValue());
                         R2_Temp_data =  RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP2.RTEMP2').getValue());
                         R3_Temp_data =  RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP3.RTEMP3').getValue());
                         R4_Temp_data =  RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP4.RTEMP4').getValue());
                         R5_Temp_data =  RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP5.RTEMP5').getValue());
                         R6_Temp_data =  RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP6.RTEMP6').getValue());
                         R7_Temp_data =  RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP7.RTEMP7').getValue());
                         R8_Temp_data =  RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP8.RTEMP8').getValue());
                         Local_Temp_data =  RegTemp2Deci(gc.databind.registry.getBinding('reg.LTEMP.LTEMP').getValue());
                        //Limits
                         R1_THERM_LIMIT_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP1_THERM_LIMIT.RTEMP1_THERM_LIMIT').getValue());
                         R1_THERM2_LIMIT_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP1_THERM2_LIMIT.RTEMP1_THERM2_LIMIT').getValue());
                         R1_THERM_HYS_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP1_THERM_LIMIT.RTEMP1_THERM_LIMIT').getValue())- THYS;
                         R1_THERM2_HYS_data  =    RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP1_THERM2_LIMIT.RTEMP1_THERM2_LIMIT').getValue())- THYS;
                        
                         R2_THERM_LIMIT_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP2_THERM_LIMIT.RTEMP2_THERM_LIMIT').getValue());
                         R2_THERM2_LIMIT_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP2_THERM2_LIMIT.RTEMP2_THERM2_LIMIT').getValue());
                         R2_THERM_HYS_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP2_THERM_LIMIT.RTEMP2_THERM_LIMIT').getValue())- THYS;
                         R2_THERM2_HYS_data  =    RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP2_THERM2_LIMIT.RTEMP2_THERM2_LIMIT').getValue())- THYS;
                        
                         R3_THERM_LIMIT_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP3_THERM_LIMIT.RTEMP3_THERM_LIMIT').getValue());
                         R3_THERM2_LIMIT_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP3_THERM2_LIMIT.RTEMP3_THERM2_LIMIT').getValue());
                         R3_THERM_HYS_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP3_THERM_LIMIT.RTEMP3_THERM_LIMIT').getValue())- THYS;
                         R3_THERM2_HYS_data  =    RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP3_THERM2_LIMIT.RTEMP3_THERM2_LIMIT').getValue())- THYS;
                        
                         R4_THERM_LIMIT_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP4_THERM_LIMIT.RTEMP4_THERM_LIMIT').getValue());
                         R4_THERM2_LIMIT_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP4_THERM2_LIMIT.RTEMP4_THERM2_LIMIT').getValue());
                         R4_THERM_HYS_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP4_THERM_LIMIT.RTEMP4_THERM_LIMIT').getValue())- THYS;
                         R4_THERM2_HYS_data  =    RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP4_THERM2_LIMIT.RTEMP4_THERM2_LIMIT').getValue())- THYS;
                        
                         R5_THERM_LIMIT_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP5_THERM_LIMIT.RTEMP5_THERM_LIMIT').getValue());
                         R5_THERM2_LIMIT_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP5_THERM2_LIMIT.RTEMP5_THERM2_LIMIT').getValue());
                         R5_THERM_HYS_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP5_THERM_LIMIT.RTEMP5_THERM_LIMIT').getValue())- THYS;
                         R5_THERM2_HYS_data  =    RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP5_THERM2_LIMIT.RTEMP5_THERM2_LIMIT').getValue())- THYS;
                        
                         R6_THERM_LIMIT_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP6_THERM_LIMIT.RTEMP6_THERM_LIMIT').getValue());
                         R6_THERM2_LIMIT_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP6_THERM2_LIMIT.RTEMP6_THERM2_LIMIT').getValue());
                         R6_THERM_HYS_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP6_THERM_LIMIT.RTEMP6_THERM_LIMIT').getValue())- THYS;
                         R6_THERM2_HYS_data  =    RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP6_THERM2_LIMIT.RTEMP6_THERM2_LIMIT').getValue())- THYS;
                                                                        
                         R7_THERM_LIMIT_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP7_THERM_LIMIT.RTEMP7_THERM_LIMIT').getValue());
                         R7_THERM2_LIMIT_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP7_THERM2_LIMIT.RTEMP7_THERM2_LIMIT').getValue());
                         R7_THERM_HYS_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP7_THERM_LIMIT.RTEMP7_THERM_LIMIT').getValue())- THYS;
                         R7_THERM2_HYS_data  =    RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP7_THERM2_LIMIT.RTEMP7_THERM2_LIMIT').getValue())- THYS;
                        
                         R8_THERM_LIMIT_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP8_THERM_LIMIT.RTEMP8_THERM_LIMIT').getValue());
                         R8_THERM2_LIMIT_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP8_THERM2_LIMIT.RTEMP8_THERM2_LIMIT').getValue());
                         R8_THERM_HYS_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP8_THERM_LIMIT.RTEMP8_THERM_LIMIT').getValue())- THYS;
                         R8_THERM2_HYS_data  =    RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP8_THERM2_LIMIT.RTEMP8_THERM2_LIMIT').getValue())- THYS;
                                   
                         Local_THERM_LIMIT_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.Local_THERM.LTHERM').getValue());
                         Local_THERM2_LIMIT_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.Local_THERM2.LTHERM2').getValue());
                         Local_THERM_HYS_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.Local_THERM.LTHERM').getValue())- THYS;
                         Local_THERM2_HYS_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.Local_THERM2.LTHERM2').getValue())- THYS;
            

					graphdraw();

			
            });
            
			templateObj.$.ti_widget_button_cleardata.addEventListener("click", function(event) {
                    graphclear();
            });
			templateObj.$.ti_tile_toggleswitch_reglock.addEventListener("changed", function(event) {
                    var bind = gc.databind.registry.getBinding('reg.LOCK.LOCK');
                    if(templateObj.$.ti_tile_toggleswitch_reglock.value){
            				bind.setValue(23718);
                    }
                    else{
                        bind.setValue(60185);
                    }
            });
            

//Channel Container Color Fault,
    gc.databind.registry.getBinding('reg.THERM_Status').addStreamingListener({
        onDataReceived: function(value) {
            
//Channel Container Color Fault,
                var LTHERM1_STATUS = gc.databind.registry.getBinding('reg.THERM_Status.LTHERM_Status').getValue();
                var RTHERM1_STATUS = gc.databind.registry.getBinding('reg.THERM_Status.RTHERM_Status').getValue();
                var LTHERM2_STATUS = gc.databind.registry.getBinding('reg.THERM2_Status.LTHERM2_Status').getValue();
                var RTHERM2_STATUS = gc.databind.registry.getBinding('reg.THERM2_Status.RTHERM2_Status').getValue();
                var ROPEN_STATUS = gc.databind.registry.getBinding('reg.REMOTE_CH_OPEN.REMOTE_CH_OPEN').getValue();
////Graph LEDs




templateObj.$.ti_widget_led_all.on = (LTHERM1_STATUS |RTHERM1_STATUS|RTHERM2_STATUS|LTHERM2_STATUS|LTHERM2_STATUS);
templateObj.$.ti_widget_led_Local.on = ((LTHERM1_STATUS&1 === 1 | LTHERM2_STATUS&1) === 1);
templateObj.$.ti_widget_led_R1.on = (((RTHERM1_STATUS&1)|(RTHERM2_STATUS&1)) === 1);
templateObj.$.ti_widget_led_R2.on = (((RTHERM1_STATUS&2)|(RTHERM2_STATUS&2)) === 2);
templateObj.$.ti_widget_led_R3.on = (((RTHERM1_STATUS&4)|(RTHERM2_STATUS&4)) === 4);
templateObj.$.ti_widget_led_R4.on = (((RTHERM1_STATUS&8)|(RTHERM2_STATUS&8)) === 8);
templateObj.$.ti_widget_led_R5.on = (((RTHERM1_STATUS&16)|(RTHERM2_STATUS&16)) === 16);
templateObj.$.ti_widget_led_R6.on = (((RTHERM1_STATUS&32)|(RTHERM2_STATUS&32)) === 32);
templateObj.$.ti_widget_led_R7.on = (((RTHERM1_STATUS&64)|(RTHERM2_STATUS&64)) === 64);
templateObj.$.ti_widget_led_R8.on = (((RTHERM1_STATUS&128)|(RTHERM2_STATUS&128)) === 128);


///Local Channel Color
             if(templateObj.$.ti_widget_checkbox_LEN.checked){
				templateObj.$.ti_widget_container67.style.backgroundColor = '#f2f2f2';
                if(LTHERM1_STATUS&1 === 1){
                    templateObj.$.ti_widget_container46.style.backgroundColor = '#ff8080';
                    templateObj.$.ti_widget_container58.style.backgroundColor = '#ff8080';
                    
					}
					else{
					templateObj.$.ti_widget_container46.style.backgroundColor = '#f2f2f2';
					templateObj.$.ti_widget_container58.style.backgroundColor = '#f2f2f2';
					}
					
					if(LTHERM2_STATUS&1 === 1){
					templateObj.$.ti_widget_container47.style.backgroundColor = '#ff8080';
					templateObj.$.ti_widget_container59.style.backgroundColor = '#ff8080';
					}
					else{
					templateObj.$.ti_widget_container47.style.backgroundColor = '#f2f2f2';
					templateObj.$.ti_widget_container59.style.backgroundColor = '#f2f2f2';
					}
        }
            else{
            		templateObj.$.ti_widget_container67.style.backgroundColor = '#808080';
                }    
////Remote1 Channel Color				
             if(templateObj.$.ti_widget_checkbox_CH1_EN.checked){
             	templateObj.$.ti_widget_container37.style.backgroundColor = '#f2f2f2';
                if((RTHERM1_STATUS & 1) === 1){
                    templateObj.$.ti_widget_container50.style.backgroundColor = '#ff8080';
					templateObj.$.ti_widget_container60.style.backgroundColor = '#ff8080';
					}
					else{
					templateObj.$.ti_widget_container50.style.backgroundColor = '#f2f2f2';
					templateObj.$.ti_widget_container60.style.backgroundColor = '#f2f2f2';
					}
					
					if((RTHERM2_STATUS & 1) === 1){
					templateObj.$.ti_widget_container51.style.backgroundColor = '#ff8080';
					templateObj.$.ti_widget_container61.style.backgroundColor = '#ff8080';
					}
					else{
					templateObj.$.ti_widget_container51.style.backgroundColor = '#f2f2f2';
					templateObj.$.ti_widget_container61.style.backgroundColor = '#f2f2f2';
					}					
					
					if((ROPEN_STATUS & 1) === 1){
					templateObj.$.ti_widget_container11.style.backgroundColor = '#ffff66';
					}
					else{
					templateObj.$.ti_widget_container11.style.backgroundColor = '#E5E5E5';
					}
        }
            else{
            		templateObj.$.ti_widget_container37.style.backgroundColor = '#808080';
                }   
////Remote2 Channel Color				
             if(templateObj.$.ti_widget_checkbox_CH2_EN.checked){
             	templateObj.$.ti_widget_container87.style.backgroundColor = '#f2f2f2';
                if((RTHERM1_STATUS & 2) === 2){
                    templateObj.$.ti_widget_container83.style.backgroundColor = '#ff8080';
					templateObj.$.ti_widget_container65.style.backgroundColor = '#ff8080';
					}
					else{
					templateObj.$.ti_widget_container83.style.backgroundColor = '#f2f2f2';
					templateObj.$.ti_widget_container65.style.backgroundColor = '#f2f2f2';
					}
					
					if((RTHERM2_STATUS & 2) === 2){
					templateObj.$.ti_widget_container84.style.backgroundColor = '#ff8080';
					templateObj.$.ti_widget_container66.style.backgroundColor = '#ff8080';
					}
					else{
					templateObj.$.ti_widget_container84.style.backgroundColor = '#f2f2f2';
					templateObj.$.ti_widget_container66.style.backgroundColor = '#f2f2f2';
					}					
					
					if((ROPEN_STATUS & 2) === 2){
					templateObj.$.ti_widget_container69.style.backgroundColor = '#ffff66';
					}
					else{
					templateObj.$.ti_widget_container69.style.backgroundColor = '#E5E5E5';
					}
        }
            else{
            		templateObj.$.ti_widget_container87.style.backgroundColor = '#808080';
                }  
////Remote3 Channel Color				
             if(templateObj.$.ti_widget_checkbox_CH3_EN.checked){
             	templateObj.$.ti_widget_container108.style.backgroundColor = '#f2f2f2';
                if((RTHERM1_STATUS & 4) === 4){
                    templateObj.$.ti_widget_container104.style.backgroundColor = '#ff8080';
					templateObj.$.ti_widget_container132.style.backgroundColor = '#ff8080';
					}
					else{
					templateObj.$.ti_widget_container104.style.backgroundColor = '#f2f2f2';
					templateObj.$.ti_widget_container132.style.backgroundColor = '#f2f2f2';
					}
					
					if((RTHERM2_STATUS & 4) === 4){
					templateObj.$.ti_widget_container105.style.backgroundColor = '#ff8080';
					templateObj.$.ti_widget_container133.style.backgroundColor = '#ff8080';
					}
					else{
					templateObj.$.ti_widget_container105.style.backgroundColor = '#f2f2f2';
					templateObj.$.ti_widget_container133.style.backgroundColor = '#f2f2f2';
					}					
					
					if((ROPEN_STATUS & 4) === 4){
					templateObj.$.ti_widget_container102.style.backgroundColor = '#ffff66';
					}
					else{
					templateObj.$.ti_widget_container102.style.backgroundColor = '#E5E5E5';
					}
        }
            else{
            		templateObj.$.ti_widget_container108.style.backgroundColor = '#808080';
                }  
////Remote4 Channel Color				
             if(templateObj.$.ti_widget_checkbox_CH4_EN.checked){
             	templateObj.$.ti_widget_container115.style.backgroundColor = '#f2f2f2';
                if((RTHERM1_STATUS & 8) === 8){
                    templateObj.$.ti_widget_container111.style.backgroundColor = '#ff8080';
					templateObj.$.ti_widget_container136.style.backgroundColor = '#ff8080';
					}
					else{
					templateObj.$.ti_widget_container111.style.backgroundColor = '#f2f2f2';
					templateObj.$.ti_widget_container136.style.backgroundColor = '#f2f2f2';
					}
					
					if((RTHERM2_STATUS & 8) === 8){
					templateObj.$.ti_widget_container112.style.backgroundColor = '#ff8080';
					templateObj.$.ti_widget_container137.style.backgroundColor = '#ff8080';
					}
					else{
					templateObj.$.ti_widget_container112.style.backgroundColor = '#f2f2f2';
					templateObj.$.ti_widget_container137.style.backgroundColor = '#f2f2f2';
					}					
					
					if((ROPEN_STATUS & 8) === 8){
					templateObj.$.ti_widget_container109.style.backgroundColor = '#ffff66';
					}
					else{
					templateObj.$.ti_widget_container109.style.backgroundColor = '#E5E5E5';
					}
        }
            else{
            		templateObj.$.ti_widget_container115.style.backgroundColor = '#808080';
                }  
////Remote5 Channel Color				
             if(templateObj.$.ti_widget_checkbox_CH5_EN.checked){
             	templateObj.$.ti_widget_container122.style.backgroundColor = '#f2f2f2';
                if((RTHERM1_STATUS & 16) === 16){
                    templateObj.$.ti_widget_container118.style.backgroundColor = '#ff8080';
					templateObj.$.ti_widget_container140.style.backgroundColor = '#ff8080';
					}
					else{
					templateObj.$.ti_widget_container118.style.backgroundColor = '#f2f2f2';
					templateObj.$.ti_widget_container140.style.backgroundColor = '#f2f2f2';
					}
					
					if((RTHERM2_STATUS & 16) === 16){
					templateObj.$.ti_widget_container119.style.backgroundColor = '#ff8080';
					templateObj.$.ti_widget_container141.style.backgroundColor = '#ff8080';
					}
					else{
					templateObj.$.ti_widget_container119.style.backgroundColor = '#f2f2f2';
					templateObj.$.ti_widget_container141.style.backgroundColor = '#f2f2f2';
					}					
					
					if((ROPEN_STATUS & 16) === 16){
					templateObj.$.ti_widget_container116.style.backgroundColor = '#ffff66';
					}
					else{
					templateObj.$.ti_widget_container116.style.backgroundColor = '#E5E5E5';
					}
        }
            else{
            		templateObj.$.ti_widget_container122.style.backgroundColor = '#808080';
                }  
////Remote6 Channel Color				
             if(templateObj.$.ti_widget_checkbox_CH6_EN.checked){
             	templateObj.$.ti_widget_container129.style.backgroundColor = '#f2f2f2';
                if((RTHERM1_STATUS & 32) === 32){
                    templateObj.$.ti_widget_container125.style.backgroundColor = '#ff8080';
					templateObj.$.ti_widget_container144.style.backgroundColor = '#ff8080';
					}
					else{
					templateObj.$.ti_widget_container125.style.backgroundColor = '#f2f2f2';
					templateObj.$.ti_widget_container144.style.backgroundColor = '#f2f2f2';
					}
					
					if((RTHERM2_STATUS & 32) === 32){
					templateObj.$.ti_widget_container126.style.backgroundColor = '#ff8080';
					templateObj.$.ti_widget_container145.style.backgroundColor = '#ff8080';
					}
					else{
					templateObj.$.ti_widget_container126.style.backgroundColor = '#f2f2f2';
					templateObj.$.ti_widget_container145.style.backgroundColor = '#f2f2f2';
					}					
					
					if((ROPEN_STATUS & 32) === 32){
					templateObj.$.ti_widget_container123.style.backgroundColor = '#ffff66';
					}
					else{
					templateObj.$.ti_widget_container123.style.backgroundColor = '#E5E5E5';
					}
        }
            else{
            		templateObj.$.ti_widget_container129.style.backgroundColor = '#808080';
                }  
////Remote7 Channel Color				
             if(templateObj.$.ti_widget_checkbox_CH7_EN.checked){
             	templateObj.$.ti_widget_container101.style.backgroundColor = '#f2f2f2';
                if((RTHERM1_STATUS & 64) === 64){
                    templateObj.$.ti_widget_container97.style.backgroundColor = '#ff8080';
					templateObj.$.ti_widget_container148.style.backgroundColor = '#ff8080';
					}
					else{
					templateObj.$.ti_widget_container97.style.backgroundColor = '#f2f2f2';
					templateObj.$.ti_widget_container148.style.backgroundColor = '#f2f2f2';
					}
					
					if((RTHERM2_STATUS & 64) === 64){
					templateObj.$.ti_widget_container98.style.backgroundColor = '#ff8080';
					templateObj.$.ti_widget_container149.style.backgroundColor = '#ff8080';
					}
					else{
					templateObj.$.ti_widget_container98.style.backgroundColor = '#f2f2f2';
					templateObj.$.ti_widget_container149.style.backgroundColor = '#f2f2f2';
					}					
					
					if((ROPEN_STATUS & 64) === 64){
					templateObj.$.ti_widget_container95.style.backgroundColor = '#ffff66';
					}
					else{
					templateObj.$.ti_widget_container95.style.backgroundColor = '#E5E5E5';
					}
        }
            else{
            		templateObj.$.ti_widget_container101.style.backgroundColor = '#808080';
                }  
////Remote8 Channe8 Color				
             if(templateObj.$.ti_widget_checkbox_CH8_EN.checked){
             	templateObj.$.ti_widget_container94.style.backgroundColor = '#f2f2f2';
                if((RTHERM1_STATUS & 128) === 128){
                    templateObj.$.ti_widget_container90.style.backgroundColor = '#ff8080';
					templateObj.$.ti_widget_container152.style.backgroundColor = '#ff8080';
					}
					else{
					templateObj.$.ti_widget_container90.style.backgroundColor = '#f2f2f2';
					templateObj.$.ti_widget_container152.style.backgroundColor = '#f2f2f2';
					}
					
					if((RTHERM2_STATUS & 128) === 128){
					templateObj.$.ti_widget_container91.style.backgroundColor = '#ff8080';
					templateObj.$.ti_widget_container153.style.backgroundColor = '#ff8080';
					}
					else{
					templateObj.$.ti_widget_container91.style.backgroundColor = '#f2f2f2';
					templateObj.$.ti_widget_container153.style.backgroundColor = '#f2f2f2';
					}					
					
					if((ROPEN_STATUS & 128) === 128){
					templateObj.$.ti_widget_container88.style.backgroundColor = '#ffff66';
					}
					else{
					templateObj.$.ti_widget_container88.style.backgroundColor = '#E5E5E5';
					}
        }
            else{
            		templateObj.$.ti_widget_container94.style.backgroundColor = '#808080';
            }
          }
    });
            //Save Chart for Scalar Graph
            templateObj.$.ti_widget_button_savechart.addEventListener("click", function(event) {
                
                //Want to print date of sample data next to heading row, need to define new date to do so.
                var today = new Date();
                var dd = today.getDate();
                var mm = today.getMonth()+1; //January is 0!
                var yyyy = today.getFullYear();
                
                if(dd<10) {
                    dd = '0'+dd
                } 
                
                if(mm<10) {
                    mm = '0'+mm
                } 
                
                today = mm + '/' + dd + '/' + yyyy;
                //End date creation

                //Print Header information for .csv file to result string
				var result = "Date," + today + "\n";
                result += "Config Reg, 0x" + gc.databind.registry.getBinding('reg.CONFIG_REG').getValue().toString(16) + "\n"; // Config Register Value
                result += "Sample #,Time,Date,Local Temperature [" + tempScale + "],Ch1 Temperature [" + tempScale + "],Ch2 Temperature [" + tempScale + "],Ch3 Temperature [" + tempScale + "],Ch4 Temperature [" + tempScale + "],Ch5 Temperature [" + tempScale + "],Ch6 Temperature [" + tempScale + "],Ch7 Temperature [" + tempScale + "],Ch8 Temperature [" + tempScale + "]" + "\n";  // Label Row for data + Date
                
                //strData0 holds values from scalar graph for series 0
                var strData0 = Local_Temp.y;
                var strData1 = Remote1_Temp.y;
                var strData2 = Remote2_Temp.y;
                var strData3 = Remote3_Temp.y;
                var strData4 = Remote4_Temp.y;
                var strData5 = Remote5_Temp.y;
                var strData6 = Remote6_Temp.y;
                var strData7 = Remote7_Temp.y;
                var strData8 = Remote8_Temp.y;
                for (var i = 0; i < strData0.length; i++) {
                    var timestamp = convertTimestamp(sampleTimeArray[i]);
                    result = result + i + ',' + timestamp + "," + strData0[i] + "," + strData1[i] + "," + strData2[i] + "," + strData3[i] + "," + strData4[i] + "," + strData5[i] + "," + strData6[i] + "," + strData7[i] + "," + strData8[i] + "\n";
                }
                
                //Save Excel File
                saveText("RemoteTempChart.csv", result);
            });

////ti_widget_droplist_refresh_rate  Off|As fast as possible|15ms Delay|50ms Delay|100ms Delay|500ms Delay|1s Delay
            templateObj.$.ti_widget_droplist_refresh_rate.addEventListener("selected",function(event){
                value = templateObj.$.ti_widget_droplist_refresh_rate.selectedText;
                switch (value) {
                    case "Off":
                        templateObj.$.ti_widget_register_page.autoReadValue = -1 ;
                        break;
                    case "As fast as possible":
                        templateObj.$.ti_widget_register_page.autoReadValue = 0 ;
                        break;
                       
                    case "15ms Delay":
                        templateObj.$.ti_widget_register_page.autoReadValue = 15 ;
                        break;
                        
                    case "50ms Delay":
                        templateObj.$.ti_widget_register_page.autoReadValue = 50 ;
                        break;
                       
                    case "100ms Delay":
                        templateObj.$.ti_widget_register_page.autoReadValue = 100 ;
                        break;
                        
                    case "500ms Delay":
                        templateObj.$.ti_widget_register_page.autoReadValue = 500;
                        break;                    
                    
                    case "1s Delay":
                        templateObj.$.ti_widget_register_page.autoReadValue = 1000;
                        break;
                   
                    default:
                        templateObj.$.ti_widget_register_page.autoReadValue = 100;
                        break;
        } 
                
            });

////ti_widget_droplist_refresh_rate  Off|As fast as possible|15ms Delay|50ms Delay|100ms Delay|500ms Delay|1s Delay
                templateObj.$.ti_widget_register_page.addEventListener("auto_read_config_changed", function (event) {
                value = templateObj.$.ti_widget_register_page.autoReadValue;
                switch (value) {
                    case "-1":
                        templateObj.$.ti_widget_droplist_refresh_rate.selectedText =  "Off";
                        break;
                    case "0":
                        templateObj.$.ti_widget_droplist_refresh_rate.selectedText =  "As fast as possible";
                        break;
                       
                    case "15":
                        templateObj.$.ti_widget_droplist_refresh_rate.selectedText = 15 ;
                        break;
                        
                    case "50":
                        templateObj.$.ti_widget_droplist_refresh_rate.selectedText = "50ms Delay" ;
                        break;
                       
                    case "100":
                        templateObj.$.ti_widget_droplist_refresh_rate.selectedText = "100ms Delay" ;
                        break;
                        
                    case "500":
                        templateObj.$.ti_widget_droplist_refresh_rate.selectedText = "500ms Delay";
                        break;                    
                    
                    case "1000":
                        templateObj.$.ti_widget_droplist_refresh_rate.selectedText = "1s Delay";
                        break;
                   
                    default:
                        templateObj.$.ti_widget_droplist_refresh_rate.selectedText = "100ms Delay";
                        break;
        } 
                
            });


            

/////PLOTLY Temperature Plot/////////////////////////////////////////////////////////////////////////////////////////

//Temperature traces            
            var Remote1_Temp = {
                x: [],
                y: [],
                mode: 'lines+markers',
                marker: {
                    color: 'purple',
                        },
                name: 'Remote 1 Temp'
            };
                        
            var Remote2_Temp = {
                x: [],
                y: [],
                mode: 'lines+markers',
                marker: {
                    color: 'cyan',
                        },
                name: 'Remote 2 Temp'
            };
                        
            var Remote3_Temp = {
                x: [],
                y: [],
                mode: 'lines+markers',
                marker: {
                    color: 'magenta',
                        },
                name: 'Remote 3 Temp'
            };
                        
            var Remote4_Temp = {
                x: [],
                y: [],
                mode: 'lines+markers',
                marker: {
                    color: 'yellow',
                        },
                name: 'Remote 4 Temp'
            };
                        
            var Remote5_Temp = {
                x: [],
                y: [],
                mode: 'lines+markers',
                marker: {
                    color: 'blue',
                        },
                name: 'Remote 5 Temp'
            };
                        
            var Remote6_Temp = {
                x: [],
                y: [],
                mode: 'lines+markers',
                marker: {
                    color: 'brown',
                        },
                name: 'Remote 6 Temp'
            };
                        
            var Remote7_Temp = {
                x: [],
                y: [],
                mode: 'lines+markers',
                marker: {
                    color: 'salmon',
                        },
                name: 'Remote 7 Temp'
            };
                        
            var Remote8_Temp = {
                x: [],
                y: [],
                mode: 'lines+markers',
                marker: {
                    color: 'gray',
                        },
                name: 'Remote 8 Temp'
            };
            
            var Local_Temp = {
                x: [],
                y: [],
                mode: 'lines+markers',
                marker: {
                    color: 'green',
                        },
                name: 'Local Temp',
            };

//Temperature Limits    
            var R1_THERM_LIMIT = {
                x: [],
                y: [],
                mode: 'lines',
                marker: {
                    color: 'red',
                        },
                name: 'Remote 1 THERM Limit'
            };

            var R1_THERM2_LIMIT = {
                x: [],
                y: [],
                mode: 'lines',
                marker: {
                    color: 'red',
                        },
                name: 'Remote 1 THERM2 Limit'
            };
            
            var R1_THERM_HYS = {
                x: [],
                y: [],
                mode: 'markers',
                marker: {
                    color: 'red',
                        },
                name: 'Remote 1 THERM Hysteresis'
            };

            var R1_THERM2_HYS = {
                x: [],
                y: [],
                mode: 'markers',
                marker: {
                    color: 'red',
                        },
                name: 'Remote 1 THERM2 Hysteresis'
            };
//////////////////            
            var R2_THERM_LIMIT = {
                x: [],
                y: [],
                mode: 'lines',
                marker: {
                    color: 'red',
                        },
                name: 'Remote 2 THERM Limit'
            };

            var R2_THERM2_LIMIT = {
                x: [],
                y: [],
                mode: 'lines',
                marker: {
                    color: 'red',
                        },
                name: 'Remote 2 THERM2 Limit'
            };
            
            var R2_THERM_HYS = {
                x: [],
                y: [],
                mode: 'markers',
                marker: {
                    color: 'red',
                        },
                name: 'Remote 2 THERM Hysteresis'
            };

            var R2_THERM2_HYS = {
                x: [],
                y: [],
                mode: 'markers',
                marker: {
                    color: 'red',
                        },
                name: 'Remote 2 THERM2 Hysteresis'
            };
//////////////////            
            var R3_THERM_LIMIT = {
                x: [],
                y: [],
                mode: 'lines',
                marker: {
                    color: 'red',
                        },
                name: 'Remote 3 THERM Limit'
            };

            var R3_THERM2_LIMIT = {
                x: [],
                y: [],
                mode: 'lines',
                marker: {
                    color: 'red',
                        },
                name: 'Remote 3 THERM2 Limit'
            };
            
            var R3_THERM_HYS = {
                x: [],
                y: [],
                mode: 'markers',
                marker: {
                    color: 'red',
                        },
                name: 'Remote 3 THERM Hysteresis'
            };

            var R3_THERM2_HYS = {
                x: [],
                y: [],
                mode: 'markers',
                marker: {
                    color: 'red',
                        },
                name: 'Remote 3 THERM2 Hysteresis'
            };
//////////////////    
            var R4_THERM_LIMIT = {
                x: [],
                y: [],
                mode: 'lines',
                marker: {
                    color: 'red',
                        },
                name: 'Remote 4 THERM Limit'
            };

            var R4_THERM2_LIMIT = {
                x: [],
                y: [],
                mode: 'lines',
                marker: {
                    color: 'red',
                        },
                name: 'Remote 4 THERM2 Limit'
            };
            
            var R4_THERM_HYS = {
                x: [],
                y: [],
                mode: 'markers',
                marker: {
                    color: 'red',
                        },
                name: 'Remote 4 THERM Hysteresis'
            };

            var R4_THERM2_HYS = {
                x: [],
                y: [],
                mode: 'markers',
                marker: {
                    color: 'red',
                        },
                name: 'Remote 4 THERM2 Hysteresis'
            };
//////////////////    
            var R5_THERM_LIMIT = {
                x: [],
                y: [],
                mode: 'lines',
                marker: {
                    color: 'red',
                        },
                name: 'Remote 5 THERM Limit'
            };

            var R5_THERM2_LIMIT = {
                x: [],
                y: [],
                mode: 'lines',
                marker: {
                    color: 'red',
                        },
                name: 'Remote 5 THERM2 Limit'
            };
            
            var R5_THERM_HYS = {
                x: [],
                y: [],
                mode: 'markers',
                marker: {
                    color: 'red',
                        },
                name: 'Remote 5 THERM Hysteresis'
            };

            var R5_THERM2_HYS = {
                x: [],
                y: [],
                mode: 'markers',
                marker: {
                    color: 'red',
                        },
                name: 'Remote 5 THERM2 Hysteresis'
            };
//////////////////            
            var R6_THERM_LIMIT = {
                x: [],
                y: [],
                mode: 'lines',
                marker: {
                    color: 'red',
                        },
                name: 'Remote 6 THERM Limit'
            };

            var R6_THERM2_LIMIT = {
                x: [],
                y: [],
                mode: 'lines',
                marker: {
                    color: 'red',
                        },
                name: 'Remote 6 THERM2 Limit'
            };
            
            var R6_THERM_HYS = {
                x: [],
                y: [],
                mode: 'markers',
                marker: {
                    color: 'red',
                        },
                name: 'Remote 6 THERM Hysteresis'
            };

            var R6_THERM2_HYS = {
                x: [],
                y: [],
                mode: 'markers',
                marker: {
                    color: 'red',
                        },
                name: 'Remote 6 THERM2 Hysteresis'
            };
//////////////////            
            var R7_THERM_LIMIT = {
                x: [],
                y: [],
                mode: 'lines',
                marker: {
                    color: 'red',
                        },
                name: 'Remote 7 THERM Limit'
            };

            var R7_THERM2_LIMIT = {
                x: [],
                y: [],
                mode: 'lines',
                marker: {
                    color: 'red',
                        },
                name: 'Remote 7 THERM2 Limit'
            };
            
            var R7_THERM_HYS = {
                x: [],
                y: [],
                mode: 'markers',
                marker: {
                    color: 'red',
                        },
                name: 'Remote 7 THERM Hysteresis'
            };

            var R7_THERM2_HYS = {
                x: [],
                y: [],
                mode: 'markers',
                marker: {
                    color: 'red',
                        },
                name: 'Remote 7 THERM2 Hysteresis'
            };
//////////////////            
            var R8_THERM_LIMIT = {
                x: [],
                y: [],
                mode: 'lines',
                marker: {
                    color: 'red',
                        },
                name: 'Remote 8 THERM Limit'
            };

            var R8_THERM2_LIMIT = {
                x: [],
                y: [],
                mode: 'lines',
                marker: {
                    color: 'red',
                        },
                name: 'Remote 8 THERM2 Limit'
            };
            
            var R8_THERM_HYS = {
                x: [],
                y: [],
                mode: 'markers',
                marker: {
                    color: 'red',
                        },
                name: 'Remote 8 THERM Hysteresis'
            };

            var R8_THERM2_HYS = {
                x: [],
                y: [],
                mode: 'markers',
                marker: {
                    color: 'red',
                        },
                name: 'Remote 8 THERM2 Hysteresis'
            };
//////////////////   
            var Local_THERM_LIMIT = {
                x: [],
                y: [],
                mode: 'lines',
                marker: {
                    color: 'red',
                        },
                name: 'Local THERM Limit'
            };

            var Local_THERM2_LIMIT = {
                x: [],
                y: [],
                mode: 'lines',
                marker: {
                    color: 'red',
                        },
                name: 'Local THERM2 Limit'
            };
            
            var Local_THERM_HYS = {
                x: [],
                y: [],
                mode: 'markers',
                marker: {
                    color: 'red',
                        },
                name: 'Local THERM Hysteresis'
            };

            var Local_THERM2_HYS = {
                x: [],
                y: [],
                mode: 'markers',
                marker: {
                    color: 'red',
                        },
                name: 'Local THERM2 Hysteresis'
            };
//////////////////
            templateObj.$.ti_widget_plot_temperature_all.data = [Remote1_Temp,Remote2_Temp,Remote3_Temp,Remote4_Temp,Remote5_Temp,Remote6_Temp,Remote7_Temp,Remote8_Temp,Local_Temp,R1_THERM_LIMIT,R1_THERM2_LIMIT,R1_THERM_HYS,R1_THERM2_HYS,R2_THERM_LIMIT,R2_THERM2_LIMIT,R2_THERM_HYS,R2_THERM2_HYS,R3_THERM_LIMIT,R3_THERM2_LIMIT,R3_THERM_HYS,R4_THERM2_HYS, R4_THERM_LIMIT,R4_THERM2_LIMIT,R4_THERM_HYS,R4_THERM2_HYS,R5_THERM_LIMIT,R5_THERM2_LIMIT,R5_THERM_HYS,R5_THERM2_HYS,R6_THERM_LIMIT,R6_THERM2_LIMIT,R6_THERM_HYS,R6_THERM2_HYS, R7_THERM_LIMIT,R7_THERM2_LIMIT,R7_THERM_HYS,R7_THERM2_HYS, R8_THERM_LIMIT,R8_THERM2_LIMIT, R8_THERM_HYS,R8_THERM2_HYS,Local_THERM_LIMIT,Local_THERM2_LIMIT,Local_THERM_HYS,Local_THERM2_HYS];
            templateObj.$.ti_widget_plot_temperature_Local.data = [Local_Temp,Local_THERM_LIMIT,Local_THERM2_LIMIT,Local_THERM_HYS,Local_THERM2_HYS];
            templateObj.$.ti_widget_plot_temperature1.data = [Remote1_Temp,R1_THERM_LIMIT,R1_THERM2_LIMIT,R1_THERM_HYS,R1_THERM2_HYS];
            templateObj.$.ti_widget_plot_temperature2.data = [Remote2_Temp,R2_THERM_LIMIT,R2_THERM2_LIMIT,R2_THERM_HYS,R2_THERM2_HYS];
            templateObj.$.ti_widget_plot_temperature3.data = [Remote3_Temp,R3_THERM_LIMIT,R3_THERM2_LIMIT,R3_THERM_HYS,R3_THERM2_HYS];
            templateObj.$.ti_widget_plot_temperature4.data = [Remote4_Temp,R4_THERM_LIMIT,R4_THERM2_LIMIT,R4_THERM_HYS,R4_THERM2_HYS];
            templateObj.$.ti_widget_plot_temperature5.data = [Remote5_Temp,R5_THERM_LIMIT,R5_THERM2_LIMIT,R5_THERM_HYS,R5_THERM2_HYS];
            templateObj.$.ti_widget_plot_temperature6.data = [Remote6_Temp,R6_THERM_LIMIT,R6_THERM2_LIMIT,R6_THERM_HYS,R6_THERM2_HYS];
            templateObj.$.ti_widget_plot_temperature7.data = [Remote7_Temp,R7_THERM_LIMIT,R7_THERM2_LIMIT,R7_THERM_HYS,R7_THERM2_HYS];
            templateObj.$.ti_widget_plot_temperature8.data = [Remote8_Temp,R8_THERM_LIMIT,R8_THERM2_LIMIT,R8_THERM_HYS,R8_THERM2_HYS];
            
            templateObj.$.ti_widget_plot_temperature_all.layout = {
              width: 500,
              height: 300,
                margin: {
                    t: 0
                },
                xaxis: {title: 'All Samples',showticklabels: false,ticks: '' },
                yaxis: {title: 'Temperature',showticklabels: true,ticks: ''}
            };
            
            templateObj.$.ti_widget_plot_temperature_Local.layout = {
              width: 500,
              height: 300,
                margin: {
                    t: 0
                },
                xaxis: {title: 'Local Channel Samples',showticklabels: false,ticks: '' },
                yaxis: {title: 'Temperature',showticklabels: true,ticks: ''}
            };            
            
            templateObj.$.ti_widget_plot_temperature1.layout = {
              width: 500,
              height: 300,
                margin: {
                    t: 0
                },
                xaxis: {title: 'Channel 1 Samples',showticklabels: false,ticks: '' },
                yaxis: {title: 'Temperature',showticklabels: true,ticks: ''}
            };            
            
            templateObj.$.ti_widget_plot_temperature2.layout = {
              width: 500,
              height: 300,
                margin: {
                    t: 0
                },
                xaxis: {title: 'Channel 2 Samples',showticklabels: false,ticks: '' },
                yaxis: {title: 'Temperature',showticklabels: true,ticks: ''}
            };            
            
            templateObj.$.ti_widget_plot_temperature3.layout = {
              width: 500,
              height: 300,
                margin: {
                    t: 0
                },
                xaxis: {title: 'Channel 3 Samples',showticklabels: false,ticks: '' },
                yaxis: {title: 'Temperature',showticklabels: true,ticks: ''}
            };            
            
            templateObj.$.ti_widget_plot_temperature4.layout = {
              width: 500,
              height: 300,
                margin: {
                    t: 0
                },
                xaxis: {title: 'Channel 4 Samples',showticklabels: false,ticks: '' },
                yaxis: {title: 'Temperature',showticklabels: true,ticks: ''}
            };            
            
            templateObj.$.ti_widget_plot_temperature5.layout = {
              width: 500,
              height: 300,
                margin: {
                    t: 0
                },
                xaxis: {title: 'Channel 5 Samples',showticklabels: false,ticks: '' },
                yaxis: {title: 'Temperature',showticklabels: true,ticks: ''}
            };            
            
            templateObj.$.ti_widget_plot_temperature6.layout = {
              width: 500,
              height: 300,
                margin: {
                    t: 0
                },
                xaxis: {title: 'Channel 6 Samples',showticklabels: false,ticks: '' },
                yaxis: {title: 'Temperature',showticklabels: true,ticks: ''}
            };            
            
            templateObj.$.ti_widget_plot_temperature7.layout = {
              width: 500,
              height: 300,
                margin: {
                    t: 0
                },
                xaxis: {title: 'Channel 7 Samples',showticklabels: false,ticks: '' },
                yaxis: {title: 'Temperature',showticklabels: true,ticks: ''}
            };            
            
            templateObj.$.ti_widget_plot_temperature8.layout = {
              width: 500,
              height: 300,
                margin: {
                    t: 0
                },
                xaxis: {title: 'Channel 8 Samples',showticklabels: false,ticks: '' },
                yaxis: {title: 'Temperature',showticklabels: true,ticks: ''}
            };            
            

  	        window.addEventListener('resize', (e) => {
  	            if( templateObj.$.ti_widget_container165.visible){
      	            let rect = templateObj.$.ti_widget_container165.getClientRects()[0];
      	            templateObj.$.ti_widget_plot_temperature_all.relayout({width: rect.width-15-15, height: rect.height});
  	            }
  	        });
            
            templateObj.$.ti_widget_checkbox_visible.addEventListener("changed", function(event) {
  	            if( templateObj.$.ti_widget_container165.visible){
      	            let rect = templateObj.$.ti_widget_container165.getClientRects()[0];
      	            templateObj.$.ti_widget_plot_temperature_all.relayout({width: rect.width-15-15, height: rect.height});
  	            }
            });   
/////////            
    
  	        window.addEventListener('resize', (e) => {
  	            if( templateObj.$.ti_widget_container158.visible){  	            
  	            let rect = templateObj.$.ti_widget_container158.getClientRects()[0];
  	            templateObj.$.ti_widget_plot_temperature_Local.relayout({width: rect.width-15, height: rect.height});
  	            }
  	        });
            
            templateObj.$.ti_widget_checkbox_visible.addEventListener("changed", function(event) {
                 if( templateObj.$.ti_widget_container158.visible){  	            
  	            let rect = templateObj.$.ti_widget_container158.getClientRects()[0];
  	            templateObj.$.ti_widget_plot_temperature_Local.relayout({width: rect.width-15, height: rect.height});
                 }
            });   
///////            
    
  	        window.addEventListener('resize', (e) => {
                if( templateObj.$.ti_widget_container162.visible){  	              	            
  	            let rect = templateObj.$.ti_widget_container162.getClientRects()[0];
  	            templateObj.$.ti_widget_plot_temperature1.relayout({width: rect.width-15, height: rect.height});
                    }
                });
            
            templateObj.$.ti_widget_checkbox_visible.addEventListener("changed", function(event) {
                if( templateObj.$.ti_widget_container162.visible){
  	            let rect = templateObj.$.ti_widget_container162.getClientRects()[0];
  	            templateObj.$.ti_widget_plot_temperature1.relayout({width: rect.width-15, height: rect.height});
                }
            });   
/////////            
    
  	        window.addEventListener('resize', (e) => {
  	            if( templateObj.$.ti_widget_container163.visible){
  	            let rect = templateObj.$.ti_widget_container163.getClientRects()[0];
  	            templateObj.$.ti_widget_plot_temperature2.relayout({width: rect.width-15, height: rect.height});
  	            }
  	        });
            
            templateObj.$.ti_widget_checkbox_visible.addEventListener("changed", function(event) {
                 if( templateObj.$.ti_widget_container163.visible){
  	            let rect = templateObj.$.ti_widget_container163.getClientRects()[0];
  	            templateObj.$.ti_widget_plot_temperature2.relayout({width: rect.width-15, height: rect.height});
  	            }
            });   
/////////            
    
  	        window.addEventListener('resize', (e) => {
  	            if( templateObj.$.ti_widget_container161.visible){
  	            let rect = templateObj.$.ti_widget_container161.getClientRects()[0];
  	            templateObj.$.ti_widget_plot_temperature3.relayout({width: rect.width-15, height: rect.height});
  	            }
  	        });
            
            templateObj.$.ti_widget_checkbox_visible.addEventListener("changed", function(event) {
                if( templateObj.$.ti_widget_container161.visible){
  	            let rect = templateObj.$.ti_widget_container161.getClientRects()[0];
  	            templateObj.$.ti_widget_plot_temperature3.relayout({width: rect.width-15, height: rect.height});
  	            }
            });   
/////////            
    
  	        window.addEventListener('resize', (e) => {
  	            if( templateObj.$.ti_widget_container160.visible){
  	            let rect = templateObj.$.ti_widget_container160.getClientRects()[0];
  	            templateObj.$.ti_widget_plot_temperature4.relayout({width: rect.width-15, height: rect.height});
  	            }
  	        });
            
            templateObj.$.ti_widget_checkbox_visible.addEventListener("changed", function(event) {
                if( templateObj.$.ti_widget_container160.visible){
  	            let rect = templateObj.$.ti_widget_container160.getClientRects()[0];
  	            templateObj.$.ti_widget_plot_temperature4.relayout({width: rect.width-15, height: rect.height});
  	            }
            });   
/////////            
    
  	        window.addEventListener('resize', (e) => {
  	            if( templateObj.$.ti_widget_container159.visible){
  	            let rect = templateObj.$.ti_widget_container159.getClientRects()[0];
  	            templateObj.$.ti_widget_plot_temperature5.relayout({width: rect.width-15, height: rect.height});
  	            }
  	        });
            
            templateObj.$.ti_widget_checkbox_visible.addEventListener("changed", function(event) {
                if( templateObj.$.ti_widget_container159.visible){
  	            let rect = templateObj.$.ti_widget_container159.getClientRects()[0];
  	            templateObj.$.ti_widget_plot_temperature5.relayout({width: rect.width-15, height: rect.height});
  	            }
            });   
/////////            
    
  	        window.addEventListener('resize', (e) => {
  	            if( templateObj.$.ti_widget_container157.visible){
  	            let rect = templateObj.$.ti_widget_container157.getClientRects()[0];
  	            templateObj.$.ti_widget_plot_temperature6.relayout({width: rect.width-15, height: rect.height});
  	            }
  	        });
            
            templateObj.$.ti_widget_checkbox_visible.addEventListener("changed", function(event) {
                if( templateObj.$.ti_widget_container157.visible){
  	            let rect = templateObj.$.ti_widget_container157.getClientRects()[0];
  	            templateObj.$.ti_widget_plot_temperature6.relayout({width: rect.width-15, height: rect.height});
  	            }
            });   
/////////            
    
  	        window.addEventListener('resize', (e) => {
  	            if( templateObj.$.ti_widget_container33.visible){
  	            let rect = templateObj.$.ti_widget_container33.getClientRects()[0];
  	            templateObj.$.ti_widget_plot_temperature7.relayout({width: rect.width-15, height: rect.height});
  	            }
  	        });
            
            templateObj.$.ti_widget_checkbox_visible.addEventListener("changed", function(event) {
                if( templateObj.$.ti_widget_container33.visible){
  	            let rect = templateObj.$.ti_widget_container33.getClientRects()[0];
  	            templateObj.$.ti_widget_plot_temperature7.relayout({width: rect.width-15, height: rect.height});
  	            }
            });   
/////////            
    
  	        window.addEventListener('resize', (e) => {
  	            if( templateObj.$.ti_widget_container164.visible){
  	            let rect = templateObj.$.ti_widget_container164.getClientRects()[0];
  	            templateObj.$.ti_widget_plot_temperature8.relayout({width: rect.width-15, height: rect.height});
  	            }
  	        });
            
            templateObj.$.ti_widget_checkbox_visible.addEventListener("changed", function(event) {
                if( templateObj.$.ti_widget_container164.visible){
  	            let rect = templateObj.$.ti_widget_container164.getClientRects()[0];
  	            templateObj.$.ti_widget_plot_temperature8.relayout({width: rect.width-15, height: rect.height});
                }
            });   
/////////            
    
    
            //Temperatures
            var THYS = RegTemp2Deci_HYS(gc.databind.registry.getBinding('reg.THERM_HYST.THERM_HYST').getValue());
            var R1_Temp_data =  RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP1.RTEMP1').getValue());
            var R2_Temp_data =  RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP2.RTEMP2').getValue());
            var R3_Temp_data =  RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP3.RTEMP3').getValue());
            var R4_Temp_data =  RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP4.RTEMP4').getValue());
            var R5_Temp_data =  RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP5.RTEMP5').getValue());
            var R6_Temp_data =  RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP6.RTEMP6').getValue());
            var R7_Temp_data =  RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP7.RTEMP7').getValue());
            var R8_Temp_data =  RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP8.RTEMP8').getValue());
            var Local_Temp_data =  RegTemp2Deci(gc.databind.registry.getBinding('reg.LTEMP.LTEMP').getValue());
            //Limits
            var R1_THERM_LIMIT_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP1_THERM_LIMIT.RTEMP1_THERM_LIMIT').getValue());
            var R1_THERM2_LIMIT_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP1_THERM2_LIMIT.RTEMP1_THERM2_LIMIT').getValue());
            var R1_THERM_HYS_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP1_THERM_LIMIT.RTEMP1_THERM_LIMIT').getValue())- THYS;
            var R1_THERM2_HYS_data  =    RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP1_THERM2_LIMIT.RTEMP1_THERM2_LIMIT').getValue())- THYS;
            
            var R2_THERM_LIMIT_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP2_THERM_LIMIT.RTEMP2_THERM_LIMIT').getValue());
            var R2_THERM2_LIMIT_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP2_THERM2_LIMIT.RTEMP2_THERM2_LIMIT').getValue());
            var R2_THERM_HYS_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP2_THERM_LIMIT.RTEMP2_THERM_LIMIT').getValue())- THYS;
            var R2_THERM2_HYS_data  =    RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP2_THERM2_LIMIT.RTEMP2_THERM2_LIMIT').getValue())- THYS;
            
            var R3_THERM_LIMIT_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP3_THERM_LIMIT.RTEMP3_THERM_LIMIT').getValue());
            var R3_THERM2_LIMIT_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP3_THERM2_LIMIT.RTEMP3_THERM2_LIMIT').getValue());
            var R3_THERM_HYS_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP3_THERM_LIMIT.RTEMP3_THERM_LIMIT').getValue())- THYS;
            var R3_THERM2_HYS_data  =    RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP3_THERM2_LIMIT.RTEMP3_THERM2_LIMIT').getValue())- THYS;
            
            var R4_THERM_LIMIT_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP4_THERM_LIMIT.RTEMP4_THERM_LIMIT').getValue());
            var R4_THERM2_LIMIT_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP4_THERM2_LIMIT.RTEMP4_THERM2_LIMIT').getValue());
            var R4_THERM_HYS_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP4_THERM_LIMIT.RTEMP4_THERM_LIMIT').getValue())- THYS;
            var R4_THERM2_HYS_data  =    RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP4_THERM2_LIMIT.RTEMP4_THERM2_LIMIT').getValue())- THYS;
            
            var R5_THERM_LIMIT_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP5_THERM_LIMIT.RTEMP5_THERM_LIMIT').getValue());
            var R5_THERM2_LIMIT_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP5_THERM2_LIMIT.RTEMP5_THERM2_LIMIT').getValue());
            var R5_THERM_HYS_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP5_THERM_LIMIT.RTEMP5_THERM_LIMIT').getValue())- THYS;
            var R5_THERM2_HYS_data  =    RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP5_THERM2_LIMIT.RTEMP5_THERM2_LIMIT').getValue())- THYS;
            
            var R6_THERM_LIMIT_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP6_THERM_LIMIT.RTEMP6_THERM_LIMIT').getValue());
            var R6_THERM2_LIMIT_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP6_THERM2_LIMIT.RTEMP6_THERM2_LIMIT').getValue());
            var R6_THERM_HYS_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP6_THERM_LIMIT.RTEMP6_THERM_LIMIT').getValue())- THYS;
            var R6_THERM2_HYS_data  =    RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP6_THERM2_LIMIT.RTEMP6_THERM2_LIMIT').getValue())- THYS;
                                                            
            var R7_THERM_LIMIT_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP7_THERM_LIMIT.RTEMP7_THERM_LIMIT').getValue());
            var R7_THERM2_LIMIT_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP7_THERM2_LIMIT.RTEMP7_THERM2_LIMIT').getValue());
            var R7_THERM_HYS_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP7_THERM_LIMIT.RTEMP7_THERM_LIMIT').getValue())- THYS;
            var R7_THERM2_HYS_data  =    RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP7_THERM2_LIMIT.RTEMP7_THERM2_LIMIT').getValue())- THYS;
            
            var R8_THERM_LIMIT_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP8_THERM_LIMIT.RTEMP8_THERM_LIMIT').getValue());
            var R8_THERM2_LIMIT_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP8_THERM2_LIMIT.RTEMP8_THERM2_LIMIT').getValue());
            var R8_THERM_HYS_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP8_THERM_LIMIT.RTEMP8_THERM_LIMIT').getValue())- THYS;
            var R8_THERM2_HYS_data  =    RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP8_THERM2_LIMIT.RTEMP8_THERM2_LIMIT').getValue())- THYS;
                       
            var Local_THERM_LIMIT_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.Local_THERM.LTHERM').getValue());
            var Local_THERM2_LIMIT_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.Local_THERM2.LTHERM2').getValue());
            var Local_THERM_HYS_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.Local_THERM.LTHERM').getValue())- THYS;
            var Local_THERM2_HYS_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.Local_THERM2.LTHERM2').getValue())- THYS;
            
            gc.databind.registry.getBinding('reg.ID.DIE_ID').addStreamingListener({
                onDataReceived: function(value) {
                    
            //Temperatures
             THYS = RegTemp2Deci_HYS(gc.databind.registry.getBinding('reg.THERM_HYST.THERM_HYST').getValue());
             R1_Temp_data =  RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP1.RTEMP1').getValue());
             R2_Temp_data =  RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP2.RTEMP2').getValue());
             R3_Temp_data =  RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP3.RTEMP3').getValue());
             R4_Temp_data =  RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP4.RTEMP4').getValue());
             R5_Temp_data =  RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP5.RTEMP5').getValue());
             R6_Temp_data =  RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP6.RTEMP6').getValue());
             R7_Temp_data =  RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP7.RTEMP7').getValue());
             R8_Temp_data =  RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP8.RTEMP8').getValue());
             Local_Temp_data =  RegTemp2Deci(gc.databind.registry.getBinding('reg.LTEMP.LTEMP').getValue());
            //Limits
             R1_THERM_LIMIT_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP1_THERM_LIMIT.RTEMP1_THERM_LIMIT').getValue());
             R1_THERM2_LIMIT_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP1_THERM2_LIMIT.RTEMP1_THERM2_LIMIT').getValue());
             R1_THERM_HYS_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP1_THERM_LIMIT.RTEMP1_THERM_LIMIT').getValue())- THYS;
             R1_THERM2_HYS_data  =    RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP1_THERM2_LIMIT.RTEMP1_THERM2_LIMIT').getValue())- THYS;
            
             R2_THERM_LIMIT_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP2_THERM_LIMIT.RTEMP2_THERM_LIMIT').getValue());
             R2_THERM2_LIMIT_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP2_THERM2_LIMIT.RTEMP2_THERM2_LIMIT').getValue());
             R2_THERM_HYS_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP2_THERM_LIMIT.RTEMP2_THERM_LIMIT').getValue())- THYS;
             R2_THERM2_HYS_data  =    RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP2_THERM2_LIMIT.RTEMP2_THERM2_LIMIT').getValue())- THYS;
            
             R3_THERM_LIMIT_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP3_THERM_LIMIT.RTEMP3_THERM_LIMIT').getValue());
             R3_THERM2_LIMIT_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP3_THERM2_LIMIT.RTEMP3_THERM2_LIMIT').getValue());
             R3_THERM_HYS_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP3_THERM_LIMIT.RTEMP3_THERM_LIMIT').getValue())- THYS;
             R3_THERM2_HYS_data  =    RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP3_THERM2_LIMIT.RTEMP3_THERM2_LIMIT').getValue())- THYS;
            
             R4_THERM_LIMIT_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP4_THERM_LIMIT.RTEMP4_THERM_LIMIT').getValue());
             R4_THERM2_LIMIT_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP4_THERM2_LIMIT.RTEMP4_THERM2_LIMIT').getValue());
             R4_THERM_HYS_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP4_THERM_LIMIT.RTEMP4_THERM_LIMIT').getValue())- THYS;
             R4_THERM2_HYS_data  =    RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP4_THERM2_LIMIT.RTEMP4_THERM2_LIMIT').getValue())- THYS;
            
             R5_THERM_LIMIT_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP5_THERM_LIMIT.RTEMP5_THERM_LIMIT').getValue());
             R5_THERM2_LIMIT_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP5_THERM2_LIMIT.RTEMP5_THERM2_LIMIT').getValue());
             R5_THERM_HYS_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP5_THERM_LIMIT.RTEMP5_THERM_LIMIT').getValue())- THYS;
             R5_THERM2_HYS_data  =    RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP5_THERM2_LIMIT.RTEMP5_THERM2_LIMIT').getValue())- THYS;
            
             R6_THERM_LIMIT_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP6_THERM_LIMIT.RTEMP6_THERM_LIMIT').getValue());
             R6_THERM2_LIMIT_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP6_THERM2_LIMIT.RTEMP6_THERM2_LIMIT').getValue());
             R6_THERM_HYS_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP6_THERM_LIMIT.RTEMP6_THERM_LIMIT').getValue())- THYS;
             R6_THERM2_HYS_data  =    RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP6_THERM2_LIMIT.RTEMP6_THERM2_LIMIT').getValue())- THYS;
                                                            
             R7_THERM_LIMIT_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP7_THERM_LIMIT.RTEMP7_THERM_LIMIT').getValue());
             R7_THERM2_LIMIT_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP7_THERM2_LIMIT.RTEMP7_THERM2_LIMIT').getValue());
             R7_THERM_HYS_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP7_THERM_LIMIT.RTEMP7_THERM_LIMIT').getValue())- THYS;
             R7_THERM2_HYS_data  =    RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP7_THERM2_LIMIT.RTEMP7_THERM2_LIMIT').getValue())- THYS;
            
             R8_THERM_LIMIT_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP8_THERM_LIMIT.RTEMP8_THERM_LIMIT').getValue());
             R8_THERM2_LIMIT_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP8_THERM2_LIMIT.RTEMP8_THERM2_LIMIT').getValue());
             R8_THERM_HYS_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP8_THERM_LIMIT.RTEMP8_THERM_LIMIT').getValue())- THYS;
             R8_THERM2_HYS_data  =    RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.RTEMP8_THERM2_LIMIT.RTEMP8_THERM2_LIMIT').getValue())- THYS;
                       
             Local_THERM_LIMIT_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.Local_THERM.LTHERM').getValue());
             Local_THERM2_LIMIT_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.Local_THERM2.LTHERM2').getValue());
             Local_THERM_HYS_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.Local_THERM.LTHERM').getValue())- THYS;
             Local_THERM2_HYS_data =  RegTemp2Deci_THERM(gc.databind.registry.getBinding('reg.Local_THERM2.LTHERM2').getValue())- THYS;

                    if(!templateObj.$.ti_widget_checkbox_Shutdown.checked){
                    graphdraw();
                    }
                } 
            });

            templateObj.$.ti_widget_plot_temperature_all.config = config = {
                'linkText': "Temperature",
                'scrollZoom': true,
                'displayModeBar': true,
                'editable': true
            };
            
            templateObj.$.ti_widget_plot_temperature_Local.config = config = {
                'linkText': "Temperature",
                'scrollZoom': true,
                'displayModeBar': true,
                'editable': true
            };
            
            templateObj.$.ti_widget_plot_temperature1.config = config = {
                'linkText': "Temperature",
                'scrollZoom': true,
                'displayModeBar': true,
                'editable': true
            };
            
            templateObj.$.ti_widget_plot_temperature2.config = config = {
                'linkText': "Temperature",
                'scrollZoom': true,
                'displayModeBar': true,
                'editable': true
            };
            
            templateObj.$.ti_widget_plot_temperature3.config = config = {
                'linkText': "Temperature",
                'scrollZoom': true,
                'displayModeBar': true,
                'editable': true
            };
            
            templateObj.$.ti_widget_plot_temperature4.config = config = {
                'linkText': "Temperature",
                'scrollZoom': true,
                'displayModeBar': true,
                'editable': true
            };
            
            templateObj.$.ti_widget_plot_temperature5.config = config = {
                'linkText': "Temperature",
                'scrollZoom': true,
                'displayModeBar': true,
                'editable': true
            };
            
            templateObj.$.ti_widget_plot_temperature6.config = config = {
                'linkText': "Temperature",
                'scrollZoom': true,
                'displayModeBar': true,
                'editable': true
            };
            
            templateObj.$.ti_widget_plot_temperature6.config = config = {
                'linkText': "Temperature",
                'scrollZoom': true,
                'displayModeBar': true,
                'editable': true
            };
            
            templateObj.$.ti_widget_plot_temperature7.config = config = {
                'linkText': "Temperature",
                'scrollZoom': true,
                'displayModeBar': true,
                'editable': true
            };
            
            templateObj.$.ti_widget_plot_temperature8.config = config = {
                'linkText': "Temperature",
                'scrollZoom': true,
                'displayModeBar': true,
                'editable': true
            };
            
            //templateObj.$.ti_widget_plot_temperature.redraw();
            var cnt = 0;

            var graphdraw = function() {
                if(gc.connectionManager.status === 'connected'){
                    
                    templateObj.$.ti_widget_plot_temperature_all.style.maxWidth = 600;
                    
                    
                    var rect = templateObj.$.ti_widget_container165.getClientRects()[0];
                    if(templateObj.$.ti_widget_vtabcontainer.selectedIndex === 3 && templateObj.$.ti_widget_container165.visible){
                    templateObj.$.ti_widget_plot_temperature_all.relayout({width: rect.width-15-10, height: rect.height});
                    }
                    
                    
                     rect = templateObj.$.ti_widget_container158.getClientRects()[0];
                    if(templateObj.$.ti_widget_vtabcontainer.selectedIndex === 3 && templateObj.$.ti_widget_container158.visible){
                    templateObj.$.ti_widget_plot_temperature_Local.relayout({width: rect.width-15, height: rect.height});
                    }
                    
                    
                     rect = templateObj.$.ti_widget_container162.getClientRects()[0];
                    if(templateObj.$.ti_widget_vtabcontainer.selectedIndex === 3 && templateObj.$.ti_widget_container162.visible){
                    templateObj.$.ti_widget_plot_temperature1.relayout({width: rect.width-15, height: rect.height});
                    }
                    
                    
                     rect = templateObj.$.ti_widget_container163.getClientRects()[0];
                    if(templateObj.$.ti_widget_vtabcontainer.selectedIndex === 3 && templateObj.$.ti_widget_container163.visible){
                    templateObj.$.ti_widget_plot_temperature2.relayout({width: rect.width-15, height: rect.height});
                    }
                    
                    
                     rect = templateObj.$.ti_widget_container161.getClientRects()[0];
                    if(templateObj.$.ti_widget_vtabcontainer.selectedIndex === 3 && templateObj.$.ti_widget_container161.visible){
                    templateObj.$.ti_widget_plot_temperature3.relayout({width: rect.width-15, height: rect.height});
                    }
                    
                    
                     rect = templateObj.$.ti_widget_container160.getClientRects()[0];
                    if(templateObj.$.ti_widget_vtabcontainer.selectedIndex === 3 && templateObj.$.ti_widget_container160.visible){
                    templateObj.$.ti_widget_plot_temperature4.relayout({width: rect.width-15, height: rect.height});
                    }
                    
                    
                     rect = templateObj.$.ti_widget_container159.getClientRects()[0];
                    if(templateObj.$.ti_widget_vtabcontainer.selectedIndex === 3 && templateObj.$.ti_widget_container159.visible){
                    templateObj.$.ti_widget_plot_temperature5.relayout({width: rect.width-15, height: rect.height});
                    }
                    
                    
                     rect = templateObj.$.ti_widget_container157.getClientRects()[0];
                    if(templateObj.$.ti_widget_vtabcontainer.selectedIndex === 3 && templateObj.$.ti_widget_container157.visible){
                    templateObj.$.ti_widget_plot_temperature6.relayout({width: rect.width-15, height: rect.height});
                    }
                    
                    
                     rect = templateObj.$.ti_widget_container33.getClientRects()[0];
                    if(templateObj.$.ti_widget_vtabcontainer.selectedIndex === 3 && templateObj.$.ti_widget_container33.visible){
                    templateObj.$.ti_widget_plot_temperature7.relayout({width: rect.width-15, height: rect.height});
                    }
                    
                    
                     rect = templateObj.$.ti_widget_container164.getClientRects()[0];
                    if(templateObj.$.ti_widget_vtabcontainer.selectedIndex === 3 && templateObj.$.ti_widget_container164.visible){
                    templateObj.$.ti_widget_plot_temperature8.relayout({width: rect.width-15, height: rect.height});
                    }
                    /////
                    
                cnt++;
                if(cnt>templateObj.$.ti_widget_droplist_samples.selectedText){
                    while(templateObj.$.ti_widget_droplist_samples.selectedText <= Remote1_Temp.x.length ){
                        Remote1_Temp.x.shift(cnt);
                        Remote2_Temp.x.shift(cnt);
                        Remote3_Temp.x.shift(cnt);
                        Remote4_Temp.x.shift(cnt);
                        Remote5_Temp.x.shift(cnt);
                        Remote6_Temp.x.shift(cnt);
                        Remote7_Temp.x.shift(cnt);
                        Remote8_Temp.x.shift(cnt);
                        
                        Local_Temp.x.shift(cnt);
                        R1_THERM_LIMIT.x.shift(cnt);
                        R1_THERM2_LIMIT.x.shift(cnt);
                        R1_THERM_HYS.x.shift(cnt);
                        R1_THERM2_HYS.x.shift(cnt);
                        
                        R2_THERM_LIMIT.x.shift(cnt);
                        R2_THERM2_LIMIT.x.shift(cnt);
                        R2_THERM_HYS.x.shift(cnt);
                        R2_THERM2_HYS.x.shift(cnt);
                        
                        R3_THERM_LIMIT.x.shift(cnt);
                        R3_THERM2_LIMIT.x.shift(cnt);
                        R3_THERM_HYS.x.shift(cnt);
                        R3_THERM2_HYS.x.shift(cnt);
                        
                        R4_THERM_LIMIT.x.shift(cnt);
                        R4_THERM2_LIMIT.x.shift(cnt);
                        R4_THERM_HYS.x.shift(cnt);
                        R4_THERM2_HYS.x.shift(cnt);
                        
                        R5_THERM_LIMIT.x.shift(cnt);
                        R5_THERM2_LIMIT.x.shift(cnt);
                        R5_THERM_HYS.x.shift(cnt);
                        R5_THERM2_HYS.x.shift(cnt);
                        
                        R6_THERM_LIMIT.x.shift(cnt);
                        R6_THERM2_LIMIT.x.shift(cnt);
                        R6_THERM_HYS.x.shift(cnt);
                        R6_THERM2_HYS.x.shift(cnt);
                        
                        R7_THERM_LIMIT.x.shift(cnt);
                        R7_THERM2_LIMIT.x.shift(cnt);
                        R7_THERM_HYS.x.shift(cnt);
                        R7_THERM2_HYS.x.shift(cnt);
                        
                        R8_THERM_LIMIT.x.shift(cnt);
                        R8_THERM2_LIMIT.x.shift(cnt);
                        R8_THERM_HYS.x.shift(cnt);
                        R8_THERM2_HYS.x.shift(cnt);
                        
                        Local_THERM_LIMIT.x.shift(cnt);
                        Local_THERM2_LIMIT.x.shift(cnt);
                        Local_THERM_HYS.x.shift(cnt);
                        Local_THERM2_HYS.x.shift(cnt);
                        
                        //update y values
                        Remote1_Temp.y.shift(R1_Temp_data);
                        Remote2_Temp.y.shift(R2_Temp_data);
                        Remote3_Temp.y.shift(R3_Temp_data);
                        Remote4_Temp.y.shift(R4_Temp_data);
                        Remote5_Temp.y.shift(R5_Temp_data);
                        Remote6_Temp.y.shift(R6_Temp_data);
                        Remote7_Temp.y.shift(R7_Temp_data);
                        Remote8_Temp.y.shift(R8_Temp_data);
                        Local_Temp.y.shift(Local_Temp_data);
                        
						R1_THERM_LIMIT.y.shift(R1_THERM_LIMIT_data);
                        R1_THERM2_LIMIT.y.shift(R1_THERM2_LIMIT_data);
                        R1_THERM_HYS.y.shift(R1_THERM_HYS_data);
                        R1_THERM2_HYS.y.shift(R1_THERM2_HYS_data);
                        
						R2_THERM_LIMIT.y.shift(R2_THERM_LIMIT_data);
                        R2_THERM2_LIMIT.y.shift(R2_THERM2_LIMIT_data);
                        R2_THERM_HYS.y.shift(R2_THERM_HYS_data);
                        R2_THERM2_HYS.y.shift(R2_THERM2_HYS_data);
                        
						R3_THERM_LIMIT.y.shift(R3_THERM_LIMIT_data);
                        R3_THERM2_LIMIT.y.shift(R3_THERM2_LIMIT_data);
                        R3_THERM_HYS.y.shift(R3_THERM_HYS_data);
                        R3_THERM2_HYS.y.shift(R3_THERM2_HYS_data);
                        
						R4_THERM_LIMIT.y.shift(R4_THERM_LIMIT_data);
                        R4_THERM2_LIMIT.y.shift(R4_THERM2_LIMIT_data);
                        R4_THERM_HYS.y.shift(R4_THERM_HYS_data);
                        R4_THERM2_HYS.y.shift(R4_THERM2_HYS_data);
                        
						R5_THERM_LIMIT.y.shift(R5_THERM_LIMIT_data);
                        R5_THERM2_LIMIT.y.shift(R5_THERM2_LIMIT_data);
                        R5_THERM_HYS.y.shift(R5_THERM_HYS_data);
                        R5_THERM2_HYS.y.shift(R5_THERM2_HYS_data);
                        
						R6_THERM_LIMIT.y.shift(R6_THERM_LIMIT_data);
                        R6_THERM2_LIMIT.y.shift(R6_THERM2_LIMIT_data);
                        R6_THERM_HYS.y.shift(R6_THERM_HYS_data);
                        R6_THERM2_HYS.y.shift(R6_THERM2_HYS_data);
                        
						R7_THERM_LIMIT.y.shift(R7_THERM_LIMIT_data);
                        R7_THERM2_LIMIT.y.shift(R7_THERM2_LIMIT_data);
                        R7_THERM_HYS.y.shift(R7_THERM_HYS_data);
                        R7_THERM2_HYS.y.shift(R7_THERM2_HYS_data);
                        
						R8_THERM_LIMIT.y.shift(R8_THERM_LIMIT_data);
                        R8_THERM2_LIMIT.y.shift(R8_THERM2_LIMIT_data);
                        R8_THERM_HYS.y.shift(R8_THERM_HYS_data);
                        R8_THERM2_HYS.y.shift(R8_THERM2_HYS_data);
                      
  					    Local_THERM_LIMIT.y.shift(Local_THERM_LIMIT_data);
                        Local_THERM2_LIMIT.y.shift(Local_THERM2_LIMIT_data);
                        Local_THERM_HYS.y.shift(Local_THERM_HYS_data);
                        Local_THERM2_HYS.y.shift(Local_THERM2_HYS_data);
                        
                        /// get date
                        var today = new Date();
                        sampleTimeArray.shift();                    
                    }
                }
                        Remote1_Temp.x.push(cnt);
                        Remote2_Temp.x.push(cnt);
                        Remote3_Temp.x.push(cnt);
                        Remote4_Temp.x.push(cnt);
                        Remote5_Temp.x.push(cnt);
                        Remote6_Temp.x.push(cnt);
                        Remote7_Temp.x.push(cnt);
                        Remote8_Temp.x.push(cnt);
                        Local_Temp.x.push(cnt);
                        R1_THERM_LIMIT.x.push(cnt);
                        R1_THERM2_LIMIT.x.push(cnt);
                        R1_THERM_HYS.x.push(cnt);
                        R1_THERM2_HYS.x.push(cnt);
                        R2_THERM_LIMIT.x.push(cnt);
                        R2_THERM2_LIMIT.x.push(cnt);
                        R2_THERM_HYS.x.push(cnt);
                        R2_THERM2_HYS.x.push(cnt);
                        R3_THERM_LIMIT.x.push(cnt);
                        R3_THERM2_LIMIT.x.push(cnt);
                        R3_THERM_HYS.x.push(cnt);
                        R4_THERM2_HYS.x.push(cnt);
                        R4_THERM_LIMIT.x.push(cnt);
                        R4_THERM2_LIMIT.x.push(cnt);
                        R4_THERM_HYS.x.push(cnt);
                        R4_THERM2_HYS.x.push(cnt);
                        R5_THERM_LIMIT.x.push(cnt);
                        R5_THERM2_LIMIT.x.push(cnt);
                        R5_THERM_HYS.x.push(cnt);
                        R5_THERM2_HYS.x.push(cnt);
                        R6_THERM_LIMIT.x.push(cnt);
                        R6_THERM2_LIMIT.x.push(cnt);
                        R6_THERM_HYS.x.push(cnt);
                        R6_THERM2_HYS.x.push(cnt);
                        R7_THERM_LIMIT.x.push(cnt);
                        R7_THERM2_LIMIT.x.push(cnt);
                        R7_THERM_HYS.x.push(cnt);
                        R7_THERM2_HYS.x.push(cnt);
                        R8_THERM_LIMIT.x.push(cnt);
                        R8_THERM2_LIMIT.x.push(cnt);
                        R8_THERM_HYS.x.push(cnt);
                        R8_THERM2_HYS.x.push(cnt);
                        Local_THERM_LIMIT.x.push(cnt);
                        Local_THERM2_LIMIT.x.push(cnt);
                        Local_THERM_HYS.x.push(cnt);
                        Local_THERM2_HYS.x.push(cnt);
                        
                        //update y values
                        Remote1_Temp.y.push(R1_Temp_data);
                        Remote2_Temp.y.push(R2_Temp_data);
                        Remote3_Temp.y.push(R3_Temp_data);
                        Remote4_Temp.y.push(R4_Temp_data);
                        Remote5_Temp.y.push(R5_Temp_data);
                        Remote6_Temp.y.push(R6_Temp_data);
                        Remote7_Temp.y.push(R7_Temp_data);
                        Remote8_Temp.y.push(R8_Temp_data);
                        Local_Temp.y.push(Local_Temp_data);
                        
						R1_THERM_LIMIT.y.push(R1_THERM_LIMIT_data);
                        R1_THERM2_LIMIT.y.push(R1_THERM2_LIMIT_data);
                        R1_THERM_HYS.y.push(R1_THERM_HYS_data);
                        R1_THERM2_HYS.y.push(R1_THERM2_HYS_data);
                        
						R2_THERM_LIMIT.y.push(R2_THERM_LIMIT_data);
                        R2_THERM2_LIMIT.y.push(R2_THERM2_LIMIT_data);
                        R2_THERM_HYS.y.push(R2_THERM_HYS_data);
                        R2_THERM2_HYS.y.push(R2_THERM2_HYS_data);
                        
						R3_THERM_LIMIT.y.push(R3_THERM_LIMIT_data);
                        R3_THERM2_LIMIT.y.push(R3_THERM2_LIMIT_data);
                        R3_THERM_HYS.y.push(R3_THERM_HYS_data);
                        R3_THERM2_HYS.y.push(R3_THERM2_HYS_data);
                        
						R4_THERM_LIMIT.y.push(R4_THERM_LIMIT_data);
                        R4_THERM2_LIMIT.y.push(R4_THERM2_LIMIT_data);
                        R4_THERM_HYS.y.push(R4_THERM_HYS_data);
                        R4_THERM2_HYS.y.push(R4_THERM2_HYS_data);
                        
						R5_THERM_LIMIT.y.push(R5_THERM_LIMIT_data);
                        R5_THERM2_LIMIT.y.push(R5_THERM2_LIMIT_data);
                        R5_THERM_HYS.y.push(R5_THERM_HYS_data);
                        R5_THERM2_HYS.y.push(R5_THERM2_HYS_data);
                        
						R6_THERM_LIMIT.y.push(R6_THERM_LIMIT_data);
                        R6_THERM2_LIMIT.y.push(R6_THERM2_LIMIT_data);
                        R6_THERM_HYS.y.push(R6_THERM_HYS_data);
                        R6_THERM2_HYS.y.push(R6_THERM2_HYS_data);
                        
						R7_THERM_LIMIT.y.push(R7_THERM_LIMIT_data);
                        R7_THERM2_LIMIT.y.push(R7_THERM2_LIMIT_data);
                        R7_THERM_HYS.y.push(R7_THERM_HYS_data);
                        R7_THERM2_HYS.y.push(R7_THERM2_HYS_data);
                        
						R8_THERM_LIMIT.y.push(R8_THERM_LIMIT_data);
                        R8_THERM2_LIMIT.y.push(R8_THERM2_LIMIT_data);
                        R8_THERM_HYS.y.push(R8_THERM_HYS_data);
                        R8_THERM2_HYS.y.push(R8_THERM2_HYS_data);
                      
  					    Local_THERM_LIMIT.y.push(Local_THERM_LIMIT_data);
                        Local_THERM2_LIMIT.y.push(Local_THERM2_LIMIT_data);
                        Local_THERM_HYS.y.push(Local_THERM_HYS_data);
                        Local_THERM2_HYS.y.push(Local_THERM2_HYS_data);
               
                ///get date
                var today = new Date();
                sampleTimeArray.push(today.getTime());

                 switch (templateObj.$.ti_widget_droplist_graph.selectedText) {
                                case "Temperature Only":
                                    templateObj.$.ti_widget_plot_temperature_all.data = [Local_Temp,Remote1_Temp,Remote2_Temp,Remote3_Temp,Remote4_Temp,Remote5_Temp,Remote6_Temp,Remote7_Temp,Remote8_Temp];
                                    templateObj.$.ti_widget_plot_temperature_Local.data = [Local_Temp];
                                    templateObj.$.ti_widget_plot_temperature1.data = [Remote1_Temp];
                                    templateObj.$.ti_widget_plot_temperature2.data = [Remote2_Temp];
                                    templateObj.$.ti_widget_plot_temperature3.data = [Remote3_Temp];
                                    templateObj.$.ti_widget_plot_temperature4.data = [Remote4_Temp];
                                    templateObj.$.ti_widget_plot_temperature5.data = [Remote5_Temp];
                                    templateObj.$.ti_widget_plot_temperature6.data = [Remote6_Temp];
                                    templateObj.$.ti_widget_plot_temperature7.data = [Remote7_Temp];
                                    templateObj.$.ti_widget_plot_temperature8.data = [Remote8_Temp];
                                    
                                    break;
                                case "Temperature and Thresholds":
                                    templateObj.$.ti_widget_plot_temperature_all.data = [Remote1_Temp,Remote2_Temp,Remote3_Temp,Remote4_Temp,Remote5_Temp,Remote6_Temp,Remote7_Temp,Remote8_Temp,Local_Temp,R1_THERM_LIMIT,R1_THERM2_LIMIT,R1_THERM_HYS,R1_THERM2_HYS,R2_THERM_LIMIT,R2_THERM2_LIMIT,R2_THERM_HYS,R2_THERM2_HYS,R3_THERM_LIMIT,R3_THERM2_LIMIT,R3_THERM_HYS,R4_THERM2_HYS, R4_THERM_LIMIT,R4_THERM2_LIMIT,R4_THERM_HYS,R4_THERM2_HYS,R5_THERM_LIMIT,R5_THERM2_LIMIT,R5_THERM_HYS,R5_THERM2_HYS,R6_THERM_LIMIT,R6_THERM2_LIMIT,R6_THERM_HYS,R6_THERM2_HYS, R7_THERM_LIMIT,R7_THERM2_LIMIT,R7_THERM_HYS,R7_THERM2_HYS, R8_THERM_LIMIT,R8_THERM2_LIMIT, R8_THERM_HYS,R8_THERM2_HYS,Local_THERM_LIMIT,Local_THERM2_LIMIT,Local_THERM_HYS,Local_THERM2_HYS];
                                    templateObj.$.ti_widget_plot_temperature_Local.data = [Local_Temp,Local_THERM_LIMIT,Local_THERM2_LIMIT,Local_THERM_HYS,Local_THERM2_HYS];
                                    templateObj.$.ti_widget_plot_temperature1.data = [Remote1_Temp,R1_THERM_LIMIT,R1_THERM2_LIMIT,R1_THERM_HYS,R1_THERM2_HYS];
                                    templateObj.$.ti_widget_plot_temperature2.data = [Remote2_Temp,R2_THERM_LIMIT,R2_THERM2_LIMIT,R2_THERM_HYS,R2_THERM2_HYS];
                                    templateObj.$.ti_widget_plot_temperature3.data = [Remote3_Temp,R3_THERM_LIMIT,R3_THERM2_LIMIT,R3_THERM_HYS,R3_THERM2_HYS];
                                    templateObj.$.ti_widget_plot_temperature4.data = [Remote4_Temp,R4_THERM_LIMIT,R4_THERM2_LIMIT,R4_THERM_HYS,R4_THERM2_HYS];
                                    templateObj.$.ti_widget_plot_temperature5.data = [Remote5_Temp,R5_THERM_LIMIT,R5_THERM2_LIMIT,R5_THERM_HYS,R5_THERM2_HYS];
                                    templateObj.$.ti_widget_plot_temperature6.data = [Remote6_Temp,R6_THERM_LIMIT,R6_THERM2_LIMIT,R6_THERM_HYS,R6_THERM2_HYS];
                                    templateObj.$.ti_widget_plot_temperature7.data = [Remote7_Temp,R7_THERM_LIMIT,R7_THERM2_LIMIT,R7_THERM_HYS,R7_THERM2_HYS];
                                    templateObj.$.ti_widget_plot_temperature8.data = [Remote8_Temp,R8_THERM_LIMIT,R8_THERM2_LIMIT,R8_THERM_HYS,R8_THERM2_HYS];
                                    break;
                                default:
                                    templateObj.$.ti_widget_plot_temperature_all.data = [Local_Temp,Remote1_Temp,Remote2_Temp,Remote3_Temp,Remote4_Temp,Remote5_Temp,Remote6_Temp,Remote7_Temp,Remote8_Temp];
                                    templateObj.$.ti_widget_plot_temperature_Local.data = [Local_Temp];
                                    templateObj.$.ti_widget_plot_temperature1.data = [Remote1_Temp];
                                    templateObj.$.ti_widget_plot_temperature2.data = [Remote2_Temp];
                                    templateObj.$.ti_widget_plot_temperature3.data = [Remote3_Temp];
                                    templateObj.$.ti_widget_plot_temperature4.data = [Remote4_Temp];
                                    templateObj.$.ti_widget_plot_temperature5.data = [Remote5_Temp];
                                    templateObj.$.ti_widget_plot_temperature6.data = [Remote6_Temp];
                                    templateObj.$.ti_widget_plot_temperature7.data = [Remote7_Temp];
                                    templateObj.$.ti_widget_plot_temperature8.data = [Remote8_Temp];
                                    break;
                    }
                templateObj.$.ti_widget_plot_temperature_all.redraw();
                templateObj.$.ti_widget_plot_temperature_Local.redraw();
                templateObj.$.ti_widget_plot_temperature1.redraw();
                templateObj.$.ti_widget_plot_temperature2.redraw();
                templateObj.$.ti_widget_plot_temperature3.redraw();
                templateObj.$.ti_widget_plot_temperature4.redraw();
                templateObj.$.ti_widget_plot_temperature5.redraw();
                templateObj.$.ti_widget_plot_temperature6.redraw();
                templateObj.$.ti_widget_plot_temperature7.redraw();
                templateObj.$.ti_widget_plot_temperature8.redraw();
                
                }
            };

/////Clear Graph////            
            var  graphclear = function() {
                cnt = 0;
                 Remote1_Temp.x = [];
                 Remote2_Temp.x = [];
                 Remote3_Temp.x = [];
                 Remote4_Temp.x = [];
                 Remote5_Temp.x = [];
                 Remote6_Temp.x = [];
                 Remote7_Temp.x = [];
                 Remote8_Temp.x = [];
                 Local_Temp.x = [];
                 R1_THERM_LIMIT.x = [];
                 R1_THERM2_LIMIT.x = [];
                 R1_THERM_HYS.x = [];
                 R1_THERM2_HYS.x = [];  
                 R2_THERM_LIMIT.x = [];
                 R2_THERM2_LIMIT.x = [];
                 R2_THERM_HYS.x = [];
                 R2_THERM2_HYS.x = [];
                 R3_THERM_LIMIT.x = [];
                 R3_THERM2_LIMIT.x = [];
                 R3_THERM_HYS.x = [];
                 R4_THERM2_HYS.x = [];
                 R4_THERM_LIMIT.x = [];
                 R4_THERM2_LIMIT.x = [];
                 R4_THERM_HYS.x = [];
                 R4_THERM2_HYS.x = [];                 
                 R5_THERM2_HYS.x = [];
                 R5_THERM_LIMIT.x = [];
                 R5_THERM2_LIMIT.x = [];
                 R5_THERM_HYS.x = [];
                 R5_THERM2_HYS.x = [];
                 R6_THERM2_HYS.x = [];
                 R6_THERM_LIMIT.x = [];
                 R6_THERM2_LIMIT.x = [];
                 R6_THERM_HYS.x = [];
                 R6_THERM2_HYS.x = [];
                 R7_THERM_LIMIT.x = [];
                 R7_THERM2_LIMIT.x = [];
                 R7_THERM_HYS.x = [];
                 R7_THERM2_HYS.x = [];
                 R7_THERM_LIMIT.x = [];
                 R7_THERM2_LIMIT.x = [];
                 R7_THERM_HYS.x = [];
                 R7_THERM2_HYS.x = [];
                 R7_THERM_LIMIT.x = [];
                 R7_THERM2_LIMIT.x = [];
                 R7_THERM_HYS.x = [];
                 R7_THERM2_HYS.x = [];   
                 R8_THERM_LIMIT.x = [];
                 R8_THERM2_LIMIT   .x = [];
                 R8_THERM_HYS.x = [];
                 R8_THERM2_HYS.x = [];
                 Local_THERM_LIMIT.x = [];
                 Local_THERM2_LIMIT.x = [];
                 Local_THERM_HYS.x = [];
                 Local_THERM2_HYS.x = [];
                //y values
                 Remote1_Temp.y = [];
                 Remote2_Temp.y = [];
                 Remote3_Temp.y = [];
                 Remote4_Temp.y = [];
                 Remote5_Temp.y = [];
                 Remote6_Temp.y = [];
                 Remote7_Temp.y = [];
                 Remote8_Temp.y = [];
                 Local_Temp.y = [];
                 R1_THERM_LIMIT.y = [];
                 R1_THERM2_LIMIT.y = [];
                 R1_THERM_HYS.y = [];
                 R1_THERM2_HYS.y = [];  
                 
                 R2_THERM_LIMIT.y = [];
                 R2_THERM2_LIMIT.y = [];
                 R2_THERM_HYS.y = [];
                 R2_THERM2_HYS.y = [];
                 
                 R3_THERM_LIMIT.y = [];
                 R3_THERM2_LIMIT.y = [];
                 R3_THERM_HYS.y = [];
                 R3_THERM2_HYS.y = [];                 
                 
                 R4_THERM2_HYS.y = [];
                 R4_THERM_LIMIT.y = [];
                 R4_THERM2_LIMIT.y = [];
                 R4_THERM_HYS.y = [];
                 R4_THERM2_HYS.y = [];
                 
                 R5_THERM_LIMIT.y = [];
                 R5_THERM2_LIMIT.y = [];
                 R5_THERM_HYS.y = [];
                 R5_THERM2_HYS.y = [];
                 
                 R6_THERM_LIMIT.y = [];
                 R6_THERM2_LIMIT.y = [];
                 R6_THERM_HYS.y = [];
                 R6_THERM2_HYS.y = [];
                 
                 R7_THERM_LIMIT.y = [];
                 R7_THERM2_LIMIT.y = [];
                 R7_THERM_HYS.y = [];
                 R7_THERM2_HYS.y = [];   
                 
                 R8_THERM_LIMIT.y = [];
                 R8_THERM2_LIMIT   .y = [];
                 R8_THERM_HYS.y = [];
                 R8_THERM2_HYS.y = [];
                 Local_THERM_LIMIT.y = [];
                 Local_THERM2_LIMIT.y = [];
                 Local_THERM_HYS.y = [];
                 Local_THERM2_HYS.y = [];
                 
                sampleTimeArray = [];
            };
            var  unitupdate = function(newunit) {
               if(newunit === 'C'){
                  Remote1_Temp.y = Remote1_Temp.y.map(getC);
				  Remote2_Temp.y = Remote2_Temp.y.map(getC)
                  Remote3_Temp.y = Remote3_Temp.y.map(getC)
                  Remote4_Temp.y = Remote4_Temp.y.map(getC)
                  Remote5_Temp.y = Remote5_Temp.y.map(getC)
                  Remote6_Temp.y = Remote6_Temp.y.map(getC)
                  Remote7_Temp.y = Remote7_Temp.y.map(getC)
                  Remote8_Temp.y = Remote8_Temp.y.map(getC)
                  Local_Temp.y = Local_Temp.y.map(getC)
                  
                  R1_THERM_LIMIT.y = R1_THERM_LIMIT.y.map(getC)
                  R1_THERM2_LIMIT.y = R1_THERM2_LIMIT.y.map(getC)
                  R1_THERM_HYS.y = R1_THERM_HYS.y.map(getC)
                  R1_THERM2_HYS.y = R1_THERM2_HYS.y.map(getC)  
                 
                  R2_THERM_LIMIT.y = R2_THERM_LIMIT.y.map(getC)
                  R2_THERM2_LIMIT.y = R2_THERM2_LIMIT.y.map(getC)
                  R2_THERM_HYS.y = R2_THERM_HYS.y.map(getC)
                  R2_THERM2_HYS.y = R2_THERM2_HYS.y.map(getC)
                 
                  R3_THERM_LIMIT.y = R3_THERM_LIMIT.y.map(getC)
                  R3_THERM2_LIMIT.y = R3_THERM2_LIMIT.y.map(getC)
                  R3_THERM_HYS.y = R3_THERM_HYS.y.map(getC)
                  R3_THERM2_HYS.y = R3_THERM2_HYS.y.map(getC)                 
                 
                  R4_THERM2_HYS.y = R4_THERM2_HYS.y.map(getC)
                  R4_THERM_LIMIT.y = R4_THERM_LIMIT.y.map(getC)
                  R4_THERM2_LIMIT.y = R4_THERM2_LIMIT.y.map(getC)
                  R4_THERM_HYS.y = R4_THERM_HYS.y.map(getC)
                 
                  R5_THERM_LIMIT.y = R5_THERM_LIMIT.y.map(getC)
                  R5_THERM2_LIMIT.y = R5_THERM2_LIMIT.y.map(getC)
                  R5_THERM_HYS.y = R5_THERM_HYS.y.map(getC)
                  R5_THERM2_HYS.y = R5_THERM2_HYS.y.map(getC)
                 
                  R6_THERM_LIMIT.y = R6_THERM_LIMIT.y.map(getC)
                  R6_THERM2_LIMIT.y = R6_THERM2_LIMIT.y.map(getC)
                  R6_THERM_HYS.y = R6_THERM_HYS.y.map(getC)
                  R6_THERM2_HYS.y = R6_THERM2_HYS.y.map(getC)
                 
                  R7_THERM_LIMIT.y = R7_THERM_LIMIT.y.map(getC)
                  R7_THERM2_LIMIT.y = R7_THERM2_LIMIT.y.map(getC)
                  R7_THERM_HYS.y = R7_THERM_HYS.y.map(getC)
                  R7_THERM2_HYS.y = R7_THERM2_HYS.y.map(getC)   
                 
                  R8_THERM_LIMIT.y = R8_THERM_LIMIT.y.map(getC)
                  R8_THERM2_LIMIT.y = R8_THERM2_LIMIT.y.map(getC)
                  R8_THERM_HYS.y = R8_THERM_HYS.y.map(getC)
                  R8_THERM2_HYS.y = R8_THERM2_HYS.y.map(getC)
                  Local_THERM_LIMIT.y = Local_THERM_LIMIT.y.map(getC)
                  Local_THERM2_LIMIT.y = Local_THERM2_LIMIT.y.map(getC)
                  Local_THERM_HYS.y = Local_THERM_HYS.y.map(getC)
                  Local_THERM2_HYS.y = Local_THERM2_HYS.y.map(getC)
               }
               else{
                  Remote1_Temp.y = Remote1_Temp.y.map(getF);
				  Remote2_Temp.y = Remote2_Temp.y.map(getF)
                  Remote3_Temp.y = Remote3_Temp.y.map(getF)
                  Remote4_Temp.y = Remote4_Temp.y.map(getF)
                  Remote5_Temp.y = Remote5_Temp.y.map(getF)
                  Remote6_Temp.y = Remote6_Temp.y.map(getF)
                  Remote7_Temp.y = Remote7_Temp.y.map(getF)
                  Remote8_Temp.y = Remote8_Temp.y.map(getF)
                  Local_Temp.y = Local_Temp.y.map(getF)
                  
                  R1_THERM_LIMIT.y = R1_THERM_LIMIT.y.map(getF)
                  R1_THERM2_LIMIT.y = R1_THERM2_LIMIT.y.map(getF)
                  R1_THERM_HYS.y = R1_THERM_HYS.y.map(getF)
                  R1_THERM2_HYS.y = R1_THERM2_HYS.y.map(getF)  
                 
                  R2_THERM_LIMIT.y = R2_THERM_LIMIT.y.map(getF)
                  R2_THERM2_LIMIT.y = R2_THERM2_LIMIT.y.map(getF)
                  R2_THERM_HYS.y = R2_THERM_HYS.y.map(getF)
                  R2_THERM2_HYS.y = R2_THERM2_HYS.y.map(getF)
                 
                  R3_THERM_LIMIT.y = R3_THERM_LIMIT.y.map(getF)
                  R3_THERM2_LIMIT.y = R3_THERM2_LIMIT.y.map(getF)
                  R3_THERM_HYS.y = R3_THERM_HYS.y.map(getF)
                  R3_THERM2_HYS.y = R3_THERM2_HYS.y.map(getF)                 
                 
                  R4_THERM2_HYS.y = R4_THERM2_HYS.y.map(getF)
                  R4_THERM_LIMIT.y = R4_THERM_LIMIT.y.map(getF)
                  R4_THERM2_LIMIT.y = R4_THERM2_LIMIT.y.map(getF)
                  R4_THERM_HYS.y = R4_THERM_HYS.y.map(getF)
                 
                  R5_THERM_LIMIT.y = R5_THERM_LIMIT.y.map(getF)
                  R5_THERM2_LIMIT.y = R5_THERM2_LIMIT.y.map(getF)
                  R5_THERM_HYS.y = R5_THERM_HYS.y.map(getF)
                  R5_THERM2_HYS.y = R5_THERM2_HYS.y.map(getF)
                 
                  R6_THERM_LIMIT.y = R6_THERM_LIMIT.y.map(getF)
                  R6_THERM2_LIMIT.y = R6_THERM2_LIMIT.y.map(getF)
                  R6_THERM_HYS.y = R6_THERM_HYS.y.map(getF)
                  R6_THERM2_HYS.y = R6_THERM2_HYS.y.map(getF)
                 
                  R7_THERM_LIMIT.y = R7_THERM_LIMIT.y.map(getF)
                  R7_THERM2_LIMIT.y = R7_THERM2_LIMIT.y.map(getF)
                  R7_THERM_HYS.y = R7_THERM_HYS.y.map(getF)
                  R7_THERM2_HYS.y = R7_THERM2_HYS.y.map(getF)   
                 
                  R8_THERM_LIMIT.y = R8_THERM_LIMIT.y.map(getF)
                  R8_THERM2_LIMIT.y = R8_THERM2_LIMIT.y.map(getF)
                  R8_THERM_HYS.y = R8_THERM_HYS.y.map(getF)
                  R8_THERM2_HYS.y = R8_THERM2_HYS.y.map(getF)
                  Local_THERM_LIMIT.y = Local_THERM_LIMIT.y.map(getF)
                  Local_THERM2_LIMIT.y = Local_THERM2_LIMIT.y.map(getF)
                  Local_THERM_HYS.y = Local_THERM_HYS.y.map(getF)
                  Local_THERM2_HYS.y = Local_THERM2_HYS.y.map(getF)
               }  
            };            
            
            
            
/////Update Graph units




/////PLOTLY Temperature Plot/////////////////////////////////////////////////////////////////////////////////////////
        }, 1);
    });
};

templateObj = document.querySelector('#template_obj');
if (templateObj) {
    init();
} else {
    document.addEventListener('DOMContentLoaded', init);
}